﻿package {
	import flash.utils.Timer;
	import flash.utils.getTimer;
	import flash.events.*;
	import flash.display.*;
	
	public class Counter extends MovieClip{
		private var _counterOn:Boolean = false;
		private var _totalCount:int = 0;
		private var _duration:Number = 0;//If -1, then infinity
		private var _freq:Number = 0;//If -1, then infinity
		private var _freqMin:Number = 0;
		private var _freqMax:Number = 0;
		private var _multiple:int = 0;//# of counts per freq
		private var gameTimeFunc:Function;
		private var totalFreq:int = 0;
		private var totalDuration:int;
		private var lastTime:int;
		
		public function Counter(pDuration:Number,pFreq:Number,pMultiple:uint,pGameTimeFunc:Function,pInitialDelay:Number=0){
			_duration = pDuration;
			_freqMin = pFreq;
			_freqMax = pFreq;
			_freq = pFreq;
			_multiple = pMultiple;
			//_totalCount = pMultiple;
			gameTimeFunc = pGameTimeFunc;
			lastTime = gameTimeFunc();
			totalFreq = -pInitialDelay;
//			lastTimeDuration = lastTimeFreq;
		}
		public function setFreq(pFreqMin:Number, pFreqMax:Number){
			_freqMin = pFreqMin;
			_freqMax = pFreqMax;
			calcFreq();
		}
		private function calcFreq(){
			_freq = _freqMin + Math.random()*(_freqMax-_freqMin);
		}
		public function counting(){
			var fTimePassed:Number = gameTimeFunc()-lastTime;

			lastTime += fTimePassed;
			totalFreq += fTimePassed;
			if(totalFreq>=0){
//				if(_counterOn){
					if(totalFreq>_freq){
						totalFreq = _freq;
					}
					if(_freq == 0){
						_totalCount = _multiple;
					}
					else{
						_totalCount = Math.floor(totalFreq/_freq) * _multiple;
					}
//					if(_totalCount > 0){
//						totalFreq = totalFreq%_freq;
//						calcFreq();
//					}
//				}
//				else{
//					_totalCount = 0;
//					if(Math.floor(totalFreq/_freq) * _multiple>0){
//						totalFreq = _freq;
//					}
//				}
			}
		}
		public function resetCounter(){
			//if(_totalCount > 0){
				_totalCount = 0;
				totalFreq = 0;
				calcFreq();
			//}
		}
		public function get counterOn():Boolean{
			return _counterOn;
		}
		public function set counterOn(b:Boolean){
			_counterOn = b;
		}
		public function get totalCount():uint{
			return _totalCount;
		}
	}
}