﻿package {
	import flash.display.*;
	import flash.events.*;
	import flash.utils.getTimer;
	import flash.utils.getDefinitionByName;
	import flash.utils.getQualifiedClassName;
	import flash.geom.Point;
	import flash.media.Sound;
	import flash.media.SoundTransform;
	import flash.geom.ColorTransform;
	import flash.filters.*;
	import fl.motion.Color;
	
	public class Damage extends MovieClip{
		private var gameTimeFunc:Function;
		private var tempImmunityArray:Array = new Array(0);
		private var aOAFTArray:Array = new Array(0);
		private var playerHitOn:Boolean = false;
		private var physObj:PhysObj;
		private var ptBStorageArray:Array;
		public function Damage(pPO:PhysObj,pPtBStorageArray:Array){
			physObj = pPO;
			ptBStorageArray = pPtBStorageArray;
			gameTimeFunc = Main.getMain().getGameTime;
		}
		public function removeDamage():void {
			var i:uint;
			gameTimeFunc = null;
			tempImmunityArray = null;
			physObj = null;
			ptBStorageArray = null;
			for (i=0 ; i < aOAFTArray.length; i++) {
				aOAFTArray[i]["hAFT"].removeAttackFreqTimer();
				aOAFTArray.splice(i);
				i--;
			}
			aOAFTArray = null;
		}
		public function addAFT(pPO:PhysObj,pSkillName:String,pDmgRatio:Number=1,pImmuneOn:Boolean=false){
			var fAFT:AttackFreqTimer = checkAOAFTArray(pPO);
			if(fAFT==null){//If not already in the array
				var fSkill:Skill = new Skill();
				fSkill.setSkill(pSkillName);
				var fAttackFreqTimer:AttackFreqTimer = new AttackFreqTimer(fSkill, pPO, gameTimeFunc);
//				if(pPO.skill.getStartAOConstEffectFunc()!=null){
//					pPO.skill.getStartAOConstEffectFunc()(pPO.getPlayer(),this);
//				}
				aOAFTArray.push({hPO:pPO,hDmgRatio:pDmgRatio,hAFT:fAttackFreqTimer,hHits:0});//i
//				aOAFTArray.push(fAttackFreqTimer);//i+1
//				aOAFTArray.push(0);//i+2, number of hits thus far (for aOHitMax)

				playerHitOn = true;
			}
//			if(!corpseOn){
//				if(!pPO.getCorpseOn() && !pPO.getDeathTriggerOn()){
//					if(pImmuneOn){//If hit by a melee vs. melee attack with lower priority, give this player tempImmunity from getting hit
//								//when the same melee attack is checked against this Player itself.
//						//This array resets every frame
//						tempImmunityArray.push(pPO);
//					}
//					else{
//						if(pPO.skill.getAOHitOn() && ((pPO.skill.getKDHitOn() && kDOn) || !kDOn) && !kDRiseOn){//If the AO is even able to hit anything
//							if(ArrayHelper.contains(tempImmunityArray,pPO)==null){//If not immune from this AO
//								var fAFT:AttackFreqTimer = checkAOAFTArray(pPO);
//								if(fAFT==null){//If not already in the array
//									var fAttackFreqTimer:AttackFreqTimer = new AttackFreqTimer(pPO.skill, pPO, gameTimeFunc);
//									if(pPO.skill.getStartAOConstEffectFunc()!=null){
//										pPO.skill.getStartAOConstEffectFunc()(pPO.getPlayer(),this);
//									}
//									aOAFTArray.push(pPO);//i
//									aOAFTArray.push(fAttackFreqTimer);//i+1
//									//aFTDmg();
//									//fAttackFreqTimer.setNumHits(0);
//									//playerFirstTimeHitOn = true;
//									playerHitOn = true;
//								}
//	//							else{//Show that the objects are still in physical contact
//	//								fAFT.setContactOn(true);
//	//							}
//							}
//						}
//					}
//				}
//			}
		}
		public function checkAOAFTArray(pPO:PhysObj):AttackFreqTimer{//Can be used in skill effect funcs
			if(aOAFTArray.length > 0){
				for(var i:uint=0; i<aOAFTArray.length; i++){
					if(pPO == aOAFTArray[i]["hPO"]){
						return aOAFTArray[i]["hAFT"];
					}
				}			
			}
			return null;
		}
		public function removeAFTContact(pPO:PhysObj){
			if(aOAFTArray.length > 0){
				for(var i:uint=0; i<aOAFTArray.length; i++){
					if(pPO == aOAFTArray[i]["hPO"]){
//						AttackFreqTimer(aOAFTArray[i]["hAFT"]).removeEvent();
//						aOAFTArray.splice(i, 2);
//						if(pPO.skill.getEndAOConstEffectFunc()!=null){
//							pPO.skill.getEndAOConstEffectFunc()(this);
//						}
						aOAFTArray[i]["hAFT"].setContactOn(false);
						break;
					}
				}
			}
		}
		public function aFTSetDmg(){//Loops in playerActions
		//trace(aOAFTArray.length);
			if(aOAFTArray!=null && !physObj.deathOn){
				if(aOAFTArray.length > 0){//If there is something in the aOAFTArray
					//trace("NUM HITS",aOAFTArray[1].getNumHits());
					playerHitOn = true;
					var fRndAcc:Number;
					var i:int=0;
					var k:int=0;
					
					for(i=0; i<aOAFTArray.length; i++){
						//trace(Collision.testCollision(aOAFTArray[i],physObj));
						var fTestCollision:Object = Collision.testCollision(aOAFTArray[i]["hPO"],physObj,Main.getMain());
						if(fTestCollision["hHit"]){
							aOAFTArray[i]["hAFT"].setContactOn(true);
							aOAFTArray[i]["hDmgRatio"] = fTestCollision["hDmgRatio"];
						}
						else{
							aOAFTArray[i]["hAFT"].setContactOn(false);
							aOAFTArray[i]["hDmgRatio"] = 0;
						}
						aOAFTArray[i]["hAFT"].attackFreqTimer();
						//if not in contact with AO anymore
						if(!aOAFTArray[i]["hAFT"].getAFTOn() || aOAFTArray[i]["hPO"].deathOn){
//							if(aOAFTArray[i].skill.getEndAOConstEffectFunc()!=null){
//								aOAFTArray[i].skill.getEndAOConstEffectFunc()(this);
//							}
							//AttackFreqTimer(aOAFTArray[i]["hAFT"]).removeEvent();
							aOAFTArray.splice(i,1);
							i--;
						}
					}
				}
				else{//If there is nothing in the aOAFTArray
//					if(playerFirstTimeHitOn){
//						playerFirstTimeHitOn = false;
//						playerHitOn = true;
//					}
//					else{
						playerHitOn = false;
				}
			}
		}
		public function aFTHitDmg() {
			if(aOAFTArray.length > 0){
				var i:int=0;
				var k:int=0;
				for (i = 0; i < aOAFTArray.length; i++) {
					if(aOAFTArray[i]["hAFT"].getNumHits()>0 && aOAFTArray[i]["hAFT"].getContactOn()){
						for(k=0; k<aOAFTArray[i]["hAFT"].getNumHits(); k++){//Loop for number of hits per frame (for very fast freq)
							//fRndAcc = Math.random();
							if(aOAFTArray[i]["hHits"] < aOAFTArray[i]["hAFT"].skill.getAOHitMax()){
//							if(aOAFTArray[i].getAccu()/100>=fRndAcc){//If it doesnt miss
								//+++++++++++++++++PLAYER HIT+++++++++++++++++++++++++++++
								startDmg(aOAFTArray[i]["hPO"],aOAFTArray[i]["hAFT"].skill,aOAFTArray[i]["hDmgRatio"]);//Make sure this is on bottom because can lead to death=>null objects=>calling undefined objects
								aOAFTArray[i]["hHits"]++;
								//aOAFTArray[i]["hAFT"].setContactOn(false);//Contact = true everytime addAFT is called from Game's testAllCollisions
//							}
//							else{//It missed
//								aOAFTArray[i]["hAFT"].setContactOn(false);
//								missedOn = true;
//								playerAOCollision(aOAFTArray[i]);//Make sure this is on bottom because can lead to death=>null objects=>calling undefined objects
//							}
							}
						}
						aOAFTArray[i]["hAFT"].setContactOn(false);//Contact = true everytime addAFT is called from Game's testAllCollisions
					}
				}
			}
			else{
				playerHitOn = false;
			}
		}
		private var dmgPBColor:Object = {hRed:215,hGreen:-40,hBlue:-40};
		private var healPBColor:Object = {hRed:-100,hGreen:0,hBlue:255};
		private var noDmgPBColor:Object = {hRed:150,hGreen:150,hBlue:150};
		
		private function startDmg(pPO:PhysObj,pSkill:Skill,pDmgRatio:Number=1){
			var i:int;
			var fDmgTotal:Number = pSkill.dmgRaw + pSkill.dmgRatio*pPO.physObjCreator.dmgBase;
			fDmgTotal *= pDmgRatio;
			if(pSkill.hitMultHash!=null){
				var fStartFunc:Function = function(){
					physObj.hitMultArray.push(pSkill.hitMultHash["hRatio"]);
					//physObj.hitMult *= pSkill.hitMultHash["hRatio"];
				}
				var fEndFunc:Function = function(){
					physObj.hitMultArray.splice(physObj.hitMultArray.indexOf(pSkill.hitMultHash["hRatio"]),1);
					//physObj.hitMult /= pSkill.hitMultHash["hRatio"];
				}
				var fTimedEffect:TimedEffect = new TimedEffect(fStartFunc,fEndFunc,pSkill.hitMultHash["hDuration"],gameTimeFunc,physObj.timedEffectArray);
				fTimedEffect.start();
			}
			fDmgTotal *= physObj.calcTotalHitMult();
			fDmgTotal = Math.round(fDmgTotal);
			physObj.hPCrnt += fDmgTotal;
			
			var fDef:Object;
			if(pSkill.kBFreeFall!=null || pSkill.kBHash!=null){
//				ArrayHelper.findAndRemoveAll(ControlObj(physObj).controlOffArray,"cast",1);
				for(i=0;i<physObj.timedEffectCastArray.length;i++){
					physObj.timedEffectCastArray[i].end();
					i--;
				}				
			}
			if(pSkill.kBFreeFall){
				fDef = Clone.doClone(pSkill.kBFreeFall);
				fDef["hGravity"] = 0;
				fDef["hInverseOn"] = pPO.directionFacing=="left";
				physObj.addControl(pSkill.getSkillName(),"freeFall",fDef,{hTierNum:1,hType:"replace"},-1);
			}
			if(pSkill.kBHash != null){
				switch(pSkill.kBHash["hType"]){
					case "pattern":
						fDef = Clone.doClone(pSkill.kBHash["hDef"]);
						fDef["hXInverseOn"] = pPO.directionFacing == "left";
//						if(pPO.x <= physObj.x){
//							fDef["hXInverseOn"] = false;
//						}
//						else{
//							fDef["hXInverseOn"] = true;
//						}
						physObj.addControl(pSkill.kBHash["hName"],"pattern",fDef,pSkill.kBHash["hTier"],pSkill.kBHash["hDuration"]);
						break;
					case "linear":
						//trace(physObj.x-pPO.x,physObj.y-pPO.y);
						physObj.addControl(pSkill.kBHash["hName"],"linear",{hXDist:physObj.x-pPO.x,hYDist:physObj.y-pPO.y,hVel:pSkill.kBHash["hDef"]["hVel"],hAcc:pSkill.kBHash["hDef"]["hAcc"],hSpread:pSkill.kBHash["hDef"]["hSpread"],hFixedSpread:0,hTravelTime:pSkill.kBHash["hDef"]["hTravelTime"],hMinDist:pSkill.kBHash["hDef"]["hMinDist"],hMaxDist:pSkill.kBHash["hDef"]["hMaxDist"]},pSkill.kBHash["hTier"],pSkill.kBHash["hDuration"]);					
						break;
				}
			}
			if(physObj.hPCrnt <= 0){
				physObj.deathOn = true;
			}
			var fDmgPB:PointBurst;
			if(pPO.physObjDef.selfDmg != 0){
				pPO.hPCrnt += pPO.physObjDef.selfDmg;
				if(pPO.physObjDef.pointBurstOn){
					fString = String(pPO.physObjDef.selfDmg);
					if(pPO.physObjDef.selfDmg<0){
						fColor = dmgPBColor;
					}
					else if(pPO.physObjDef.selfDmg>0){
						fString = "+" + String(pPO.physObjDef.selfDmg);
						fColor = healPBColor;
					}
					else{
						fColor = noDmgPBColor;
					}
					fDmgPB = new PointBurst(Main.getMain(),fString,pPO.x,pPO.y-12,fColor["hRed"],fColor["hGreen"],fColor["hBlue"],ptBStorageArray,gameTimeFunc,pPO);
					fDmgPB.setXDisp(-30,30);
					fDmgPB.setFontSize(10);
					fDmgPB.start();
				}
				if(pPO.hPCrnt <= 0){
					pPO.deathOn = true;
				}
			}
			var fString:String = String(fDmgTotal);
			var fColor:Object;
			if (physObj.deathOn) {

				if(physObj.physObjDef.pointBurstOn && Math.abs(fDmgTotal)!=0){
	//				fDmgPB = new PointBurst(physObj, String(fDmgTotal), 0, -12, 215, -40, -40, ptBStorageArray, gameTimeFunc);
	//				fDmgPB.setXDisp(-30,30);
	//				//fDmgPB.setFontSize(50);
	//				fDmgPB.start();
					if(fDmgTotal<0){
						fColor = dmgPBColor;
					}
					else if(fDmgTotal>0){
						fString = "+" + String(fDmgTotal);
						fColor = healPBColor;
					}
					else{
						fColor = noDmgPBColor;
					}
					fDmgPB = new PointBurst(Main.getMain(), fString, physObj.x, physObj.y, fColor["hRed"],fColor["hGreen"],fColor["hBlue"], ptBStorageArray, gameTimeFunc, physObj);
					fDmgPB.setXDisp(0,0);
					if(Math.abs(fDmgTotal)>100){
						fDmgPB.setFontSize(20);
					}
					else if(Math.abs(fDmgTotal)>50){
						fDmgPB.setFontSize(15);
					}
					else if(Math.abs(fDmgTotal)>10){
						fDmgPB.setFontSize(12);
					}
					else{
						fDmgPB.setFontSize(10);
					}
					fDmgPB.start();
				}
			}
			else{
				function getMidPoint(pPhysObj:PhysObj):Object{
					var fX:Number = pPhysObj.x;
					var fY:Number = pPhysObj.y;
					var fMC:MovieClip = pPhysObj;
					if (pPhysObj.crntGraphicInner != null) {
						fMC = pPhysObj.crntGraphicInner;
						fX += pPhysObj.crntGraphicInner.x;
						fY += pPhysObj.crntGraphicInner.y;
					}
					switch(pPhysObj.physObjDef.mCAlignXY["hX"]){
						case "left":
							fX += fMC.width/2;
							break;
						case "right":
							fX -= fMC.width/2;
							break;
					}
					switch(pPhysObj.physObjDef.mCAlignXY["hY"]){
						case "top":
							fY += fMC.height/2;
							break;
						case "bottom":
							fY -= fMC.height/2;
							break;
					}
					return {hX:fX,hY:fY,hWidth:fMC.width,hHeight:fMC.height};
				}
				var fPOMid:Object = getMidPoint(pPO);
				var fPhysObjMid:Object = getMidPoint(physObj);

				//var fXIntersect:Number = fPOMid["hX"] + .5*(fPhysObjMid["hX"]-fPOMid["hX"]);
				//var fYIntersect:Number = fPOMid["hY"] + .5*(fPhysObjMid["hY"]-fPOMid["hY"]);
				var fXIntersect:Number = .5*Math.max(fPOMid["hX"]-fPOMid["hWidth"]/2,fPhysObjMid["hX"]-fPhysObjMid["hWidth"]/2) + .5*Math.min(fPOMid["hX"]+fPOMid["hWidth"]/2,fPhysObjMid["hX"]+fPhysObjMid["hWidth"]/2);
				var fYIntersect:Number = .5*Math.max(fPOMid["hY"]-fPOMid["hHeight"]/2,fPhysObjMid["hY"]-fPhysObjMid["hHeight"]/2) + .5*Math.min(fPOMid["hY"]+fPOMid["hHeight"]/2,fPhysObjMid["hY"]+fPhysObjMid["hHeight"]/2);
				
				if(physObj.physObjDef.pointBurstOn && Math.abs(fDmgTotal)!=0){
	//				fDmgPB = new PointBurst(physObj, String(fDmgTotal), 0, -12, 215, -40, -40, ptBStorageArray, gameTimeFunc);
	//				fDmgPB.setXDisp(-30,30);
	//				//fDmgPB.setFontSize(50);
	//				fDmgPB.start();
					if(fDmgTotal<0){
						fColor = dmgPBColor;
					}
					else if(fDmgTotal>0){
						fString = "+" + String(fDmgTotal);
						fColor = healPBColor;
					}
					else{
						fColor = noDmgPBColor;
					}
					fDmgPB = new PointBurst(Main.getMain(), fString, fXIntersect, fYIntersect, fColor["hRed"],fColor["hGreen"],fColor["hBlue"], ptBStorageArray, gameTimeFunc, physObj);
					fDmgPB.setXDisp(0,0);
					if(Math.abs(fDmgTotal)>100){
						fDmgPB.setFontSize(20);
					}
					else if(Math.abs(fDmgTotal)>50){
						fDmgPB.setFontSize(15);
					}
					else if(Math.abs(fDmgTotal)>10){
						fDmgPB.setFontSize(12);
					}
					else{
						fDmgPB.setFontSize(10);
					}
					fDmgPB.start();
				}
				//physObj.
			}
		}
	}
}