﻿package{
	import flash.display.*;
	import flash.events.*;

	public class Intro extends MovieClip {
		private var introMovieNum:int = 0;
		private var introMCArray:Array;
		private var _currentIntroMC:MovieClip;
		public function get currentIntroMC():MovieClip {
			return _currentIntroMC;
		}
		private var bGSoundEffect:SoundEffect;
		private var musicOn:Boolean = true;
		private var sStage:Stage;
		private var endFunc:Function;
		public function Intro(pStage:Stage):void{
			sStage = pStage;
		}			
		public function startIntro(pMCArray:Array, pSE:SoundEffect,pEndFunc:Function){
			introMCArray = pMCArray;
			endFunc = pEndFunc;
			for(var i:uint=0; i<introMCArray.length; i++){
				MovieClip(introMCArray[i]).stop();
			}
			introMovieNum = 0;
			addChild(introMCArray[introMovieNum]);
			introMCArray[introMovieNum].x=0;
			introMCArray[introMovieNum].y=0;
			introMCArray[introMovieNum].visible = true;
			_currentIntroMC = introMCArray[introMovieNum];
			_currentIntroMC.gotoAndPlay(0);
			
			bGSoundEffect = pSE;
/*
			if(!bGSoundEffect){
				bGSoundEffect.stopSoundEffect();
				bGSoundEffect.removeSoundEffect();
				bGSoundEffect = null;
			}*/
			//sStage.addEventListener(MouseEvent.CLICK, mouseEndIntroMovie);
			addEventListener(Event.ENTER_FRAME, checkEndIntroMovie);
		}
		/*
		private function playIntroSound(pVolume:Number = .3){
			if(!musicOn){
				pVolume = 0;
			}
			if(bGSoundEffect!=null){
				if(bGSoundEffect.getSoundName()!=introBGSoundName){
					bGSoundEffect.stopSoundEffect();
					bGSoundEffect.removeSoundEffect();
					bGSoundEffect = new SoundEffect(introBGSoundName,0,getGameTime,gameSoundEffectArray);
					bGSoundEffect.startIntroLoopSoundEffect(introBGSoundName);
					bGSoundEffect.startFadeInSoundEffect(transDuration/2,0,pVolume);
				} 
				else{//If same sound as prev area
					bGSoundEffect.startFadeInSoundEffect(transDuration/2,0,pVolume);
				}
			}
			else{
				bGSoundEffect = new SoundEffect(introBGSoundName,pVolume,getGameTime,gameSoundEffectArray);
				bGSoundEffect.startIntroLoopSoundEffect(introBGSoundName);
				//bGSoundEffect.startFadeInSoundEffect(transDuration/2,0,pVolume);
			}
		}
		private function endAllEchoSound(){
			for(var i:uint=0;i<gameSoundEffectArray.length;i++){
				if(gameSoundEffectArray[i] is SoundEffect){
					if(gameSoundEffectArray[i].getEchoOn()){
						gameSoundEffectArray[i].stopSoundEffect();
					}
				}
			}
		}*/
		private function mouseEndIntroMovie(e:MouseEvent){
			if(_currentIntroMC!=null){
				if(e.target==_currentIntroMC.btnExit){
					if(_currentIntroMC!=null){
						sStage.removeEventListener(MouseEvent.CLICK, mouseEndIntroMovie);
						_currentIntroMC.gotoAndStop("end");
					}
				}
			}
			else{
				sStage.removeEventListener(MouseEvent.CLICK, mouseEndIntroMovie);
			}
			sStage.focus = sStage;
		}
		private function checkEndIntroMovie(e:Event){
			if(MovieClip(introMCArray[introMovieNum]).currentLabel == "startBGM"){
				if(bGSoundEffect==null){
					//playIntroSound();
				}
			}
			else if(MovieClip(introMCArray[introMovieNum]).currentLabel == "end"){
				if(introMovieNum<introMCArray.length-1){
					introMovieNum+=1;
					_currentIntroMC.stop();
					removeChild(_currentIntroMC);
					introMCArray[introMovieNum].x=0;
					introMCArray[introMovieNum].y=0;
					introMCArray[introMovieNum].visible = true;
					_currentIntroMC = introMCArray[introMovieNum];
					_currentIntroMC.gotoAndPlay(0);
					this.addChild(introMCArray[introMovieNum]);
					sStage.focus = sStage;
				}
				else{
					//gotoTitleScreen();
					//Remove Intro Movie
					_currentIntroMC.stop();
					removeChild(_currentIntroMC);
					_currentIntroMC = null;
					introMCArray = null;
					removeEventListener(Event.ENTER_FRAME, checkEndIntroMovie);
					endFunc();
				}
			}
		}
	}
}