﻿package {
	import flash.display.*;
	import flash.events.*;
	import flash.utils.getTimer;
	import flash.geom.Point;
	import flash.text.*;
	import flash.net.SharedObject;
	import flash.net.URLRequest;
	import flash.net.navigateToURL;
	import flash.geom.ColorTransform;//For when selected same char
	import flash.display.LoaderInfo;
	import flash.ui.ContextMenu;
	//import flash.ui.ContextMenu.hideBuiltInItems;
	import flash.utils.getQualifiedClassName;
	
	public dynamic class Main extends MovieClip {
		private static var main:Main;
		
		private var intro:Intro;
		
		private var trainingOn:Boolean = false;//If in training mode
		private var cpuTrainingOn:Boolean = false;//If training with CPU
		
		//private var transitionBG:TransitionBG;
		private var transitionOn:Boolean = false;
		private var transitionPostGameMode:String;
		private var transitionMidFunc:Function;
		private var transitionMidFuncOn:Boolean = false;
		private var transDuration:uint = 1000;
		
		static const KEY_1:uint = 49;
		static const KEY_2:uint = 50;
		static const KEY_3:uint = 51;
		static const KEY_W:uint = 87;
		static const KEY_A:uint = 65;
		static const KEY_S:uint = 83;
		static const KEY_D:uint = 68;
		
		private var mouseDownOn:Boolean = false;
		
		private var lvlDefCrnt:LvlDef;
		
		private var _ptBStorageArray:Array = new Array(0);
		
		public function get ptBStorageArray():Array{
			return _ptBStorageArray;
		}
		public function Main():void{
			main = this;
			addEventListener(Event.ADDED_TO_STAGE, stageAddedFunc);
		}
		private function stageAddedFunc(e:Event){
			stage.frameRate = 30;
			stage.scaleMode = StageScaleMode.NO_BORDER;
			stage.focus = stage;
			stage.quality = "high";
			
//			for(i=0; i<this.numChildren; i++){
//				switch(this.getChildAt(i)){
//					case mochiAdBG:
//						break;
//					default:
//						removeChild(this.getChildAt(i));
//						i--;
//				}
//			}
			
			var rightClick:ContextMenu = new ContextMenu();//create a new right click menu called rightClick
			rightClick.hideBuiltInItems();//hide the built in options of the right click menu
			this.contextMenu = rightClick;//make the neccesary changes to the right click menu


//			if (testSiteLock()) {
//				trace("Wrong site!");
//			}
//			else{
				addEventListener(Event.ENTER_FRAME, checkAdEnd);
//			}
		}
		private function checkAdEnd(e:Event){
			//if(currentLabel == "endAd"){
				removeEventListener(Event.ENTER_FRAME, checkAdEnd);
				preloaderStartFunc();
			//}
		}
		private function preloaderStartFunc(){
			intro = new Intro(stage);
			intro.startIntro([new IntroMC()],null,initiateGame);
			addChild(intro);
			intro.x = 0;//stage.stageWidth/2;
			intro.y = 0;//stage.stageHeight/2;
			titleScreen = new TitleScreen();
//			preloader.loadScreen.removeEventListener(MouseEvent.CLICK, checkMouseStartGame);
//			preloader.loadScreen.stop();
/*
			var fTransFunc:Function = function(){
				for(var i:uint=0; i<numChildren; i++){
					removeChildAt(i);
					i--;
				}
				//gotoAndStop("startGame");
				
				//INITIATE CLASS VAR (Must do here since custom classes are not loaded until after the preloader completes)
				transitionBG = new TransitionBG();
				titleScreen = new TitleScreen();
				
				//Need to add again since change frames
				this.addChild(transitionBG);
				transitionBG.width = stage.stageWidth;
				transitionBG.height = stage.stageHeight;
				transitionBG.x=0;
				transitionBG.y=stage.stageHeight;
				
				initiateGame();
			}
			createTransition(fTransFunc,null);
			*/
			lvlDefCrnt = new LvlDef();
			lvlDefCrnt.setLvlDef("1");
		}
		private var titleScreen:TitleScreen;
		private var keyboardTesterInputHash:Object;
		private var keyboardTesterArray:Array = new Array(0);
		private function initiateGame(){
			addChild(titleScreen);
			keyboardTesterInputHash = {hPlayer0:{hBark:KEY_1,hBite:KEY_2,hOther:KEY_3,hUp:KEY_W,hLeft:KEY_A,hDown:KEY_S,hRight:KEY_D}
									   //hPlayer1:{hBlock:Q_CODE,hJump:W_CODE,hSkill:E_CODE,hNormal:R_CODE,hSpecial:T_CODE,hSelect:R_CODE,hDeselect:Q_CODE,hLeft:FOUR_CODE,hUp:EIGHT_CODE,hRight:SIX_CODE,hDown:FIVE_CODE}
									  };
			
			keyboardTesterArray.push(new KeyboardTester(keyboardTesterInputHash.hPlayer0,stage));
			//keyboardTesterArray.push(new KeyboardTester(keyboardTesterInputHash.hPlayer1,stage));

			stage.addEventListener(MouseEvent.CLICK, checkMainMenuMouse);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, checkMouseDown);
			stage.addEventListener(MouseEvent.MOUSE_UP, checkMouseUp);
			//stage.addEventListener(MouseEvent.MOUSE_MOVE, checkMouse);
			addEventListener(Event.ENTER_FRAME, gameLoop);
		}
		private var avatar:Avatar;
		private var boss:PhysObj;
		private var bossOn:Boolean = false;
		private var avatarArray:Array = new Array(0);
		private var bulletArray:Array = new Array(0);
		private var playerArray:Array = new Array(0);
		private var physObjArray:Array = new Array(0);
		private var _mouseX:Number = 0;
		private var _mouseY:Number = 0;

		private function checkMouseDown(e:MouseEvent){
			mouseDownOn = true;
		}
		private function checkMouseUp(e:MouseEvent){
			mouseDownOn = false;
		}
		private function checkMainMenuMouse(e:MouseEvent){
			switch(e.target){
				case titleScreen.btnStartGame:
					reset();
					createPhysObj("Dog",stage.stageWidth/2,stage.stageHeight/2,"right","avatar",false,true);
					startLvl();
					//boss = createPhysObj("Mom",stage.stageWidth,stage.stageHeight,"left","enemy",false);
					break;
			}
			if(e.target is ClickToContinueBtn){
				reset();
//				if(
//				createAO("Bark", avatar);
			}
		}
		private function createPhysObj(pName:String=null, pX:Number=0,pY:Number=0, pDirectionFacing:String=null, pTeam:String=null,pLvlMvOn:Boolean=true, pAvatarOn:Boolean=false, pOriginX:Number=0,pOriginY:Number=0,pNumMultiple:Number=0,pMouseAimOn:Boolean=false,pCreator:PhysObj=null):PhysObj{
			var fPhysObj:PhysObj;

			if(pAvatarOn){
				avatar = new Avatar(pName,keyboardTesterArray[0],getGameTime);
				avatarArray.push(avatar);
				fPhysObj = avatar;
				if(pDirectionFacing == "left"){
					fPhysObj.setDirectionFacing("left");
				}
				if(pDirectionFacing == "right"){
					fPhysObj.x = pX + pOriginX;
				}
				else{
					fPhysObj.x = pX - pOriginX;
				}
				fPhysObj.y = pY + pOriginY;
			}
			else{
				fPhysObj = new NonAvatar(pName,getGameTime);
				if(pDirectionFacing == "left"){
					fPhysObj.setDirectionFacing("left");
				}
				if(pDirectionFacing == "right"){
					fPhysObj.x = pX + pOriginX;
				}
				else{
					fPhysObj.x = pX - pOriginX;
				}
				fPhysObj.y = pY + pOriginY;

				switch(fPhysObj.physObjDef.moveType){
					case "linear":
						var fSpreadAngle:Number = 0;
						if(fPhysObj.physObjDef.multipleSpread.length > pNumMultiple){
							fSpreadAngle = fPhysObj.physObjDef.multipleSpread[pNumMultiple];
						}
						if(pMouseAimOn){
							NonAvatar(fPhysObj).linearMvCoord(mouseX-fPhysObj.x,mouseY-fPhysObj.y,fPhysObj.physObjDef.moveDef[0],fPhysObj.physObjDef.moveDef[1],fPhysObj.physObjDef.spread, fSpreadAngle);
						}
						else{
							NonAvatar(fPhysObj).linearMvCoord(avatar.x-fPhysObj.x,avatar.y-avatar.height/2-fPhysObj.y,fPhysObj.physObjDef.moveDef[0],fPhysObj.physObjDef.moveDef[1],fPhysObj.physObjDef.spread);
						}
						break;
					case "pattern":
						NonAvatar(fPhysObj).startPatternMv(fPhysObj.physObjDef.moveDef[0],fPhysObj.physObjDef.moveDef[1]);
						break;
					default:
						break;
				}
			}
			addChild(fPhysObj);

			fPhysObj.team = pTeam;
			if(pCreator==null){
				fPhysObj.physObjCreator = fPhysObj;
			}
			else{
				fPhysObj.physObjCreator = pCreator;
			}
			if(pLvlMvOn){
//			if(fPhysObj!=avatar && fPhysObj.physObjCreator!=avatar && fPhysObj!=boss && fPhysObj.physObjCreator!=boss){
				fPhysObj.mvSpeed.addMvSpeed({hName:"lvlMv",hVelX:lvlDefCrnt.lvlSpeed,hAccX:0,hVelY:0,hAccY:0,hTier:10},"add");
			}
			
			physObjArray.push(fPhysObj);
			playerArray.push(fPhysObj);
			bulletArray.push(fPhysObj);
			return fPhysObj;
		}
		private function createAO(pName:String, pPlayer:PhysObj, pNumMultiple:uint=0){
			var fMouseAimOn:Boolean = false;
			if(pPlayer == avatar){
				fMouseAimOn = true;
			}
			var fPO:PhysObj = createPhysObj(pName,pPlayer.x,pPlayer.y,pPlayer.directionFacing,pPlayer.team,pPlayer!=avatar&&pPlayer!=boss,false,pPlayer.bulletOrigin[0],pPlayer.bulletOrigin[1],pNumMultiple,fMouseAimOn,pPlayer);
			if(fPO.physObjDef.recoil != null){
				if(fPO.physObjDef.recoil["hType"] == "replace"){
					pPlayer.mvSpeed.addMvSpeed(fPO.physObjDef.recoil["hMvSpeed"],fPO.physObjDef.recoil["hType"]);
					pPlayer.velX = 0;
					pPlayer.velY = 0;
					pPlayer.accX = 0;
					pPlayer.accY = 0;
					//pPlayer.mvSpeed.mvSpeedOn = false;
				}
			}
			//Each player has own shoot origin point
//				var fBullet:NonAvatar = new NonAvatar(pName,getGameTime);
//				addChild(fBullet);
//				fBullet.team = pPlayer.team;
//				fBullet.setDirectionFacing(pPlayer.directionFacing);
//				if(pPlayer.directionFacing == "right"){
//					fBullet.x = pPlayer.x + pPlayer.bulletOrigin[0];
//				}
//				else{
//					fBullet.x = pPlayer.x - pPlayer.bulletOrigin[0];
//				}
//				fBullet.y = pPlayer.y + pPlayer.bulletOrigin[1];
//				switch(fBullet.physObjDef.moveType){
//					case "linear":
//						var fSpreadAngle:Number = 0;
//						if(fBullet.physObjDef.multipleSpread.length > pNumMultiple){
//							fSpreadAngle = fBullet.physObjDef.multipleSpread[pNumMultiple];
//						}
//						if(pPlayer == avatar){
//							fBullet.linearMvCoord(mouseX-fBullet.x,mouseY-fBullet.y,fBullet.physObjDef.moveDef[0],fBullet.physObjDef.moveDef[1],fBullet.physObjDef.spread, fSpreadAngle);
//						}
//						else{
//							fBullet.linearMvCoord(avatar.x-fBullet.x,avatar.y-avatar.height/2-fBullet.y,fBullet.physObjDef.moveDef[0],fBullet.physObjDef.moveDef[1],fBullet.physObjDef.spread, fSpreadAngle);
//						}
//						break;
//					case "pattern":
//						fBullet.startPatternMv(fBullet.physObjDef.moveDef[0],fBullet.physObjDef.moveDef[1]);
//						break;
//					default:
//						break;
//				}
//				//fBullet.startPatternMv([100,null,-100,500, -100,null,100,500],[100,null,-100,500, -100,null,100,500],avatar.directionFacing);
//				physObjArray.push(fBullet);
//				bulletArray.push(fBullet);
		}
		private function createPlayer(pName:String, pX,pY:Number, pDirectionFacing:String, pTeam:String, pAvatarOn:Boolean=false){
			var fPhysObj:PhysObj;
			if(pAvatarOn){
				avatar = new Avatar(pName,keyboardTesterArray[0],getGameTime);
				fPhysObj = avatar;
				if(pDirectionFacing == "left"){
					fPhysObj.setDirectionFacing("left");
				}
			}
			else{
				fPhysObj = new NonAvatar(pName,getGameTime);
				if(pDirectionFacing == "left"){
					fPhysObj.setDirectionFacing("left");
				}
				switch(fPhysObj.physObjDef.moveType){
					case "linear":
						NonAvatar(fPhysObj).linearMvCoord(avatar.x-fPhysObj.x,avatar.y-avatar.height/2-fPhysObj.y,fPhysObj.physObjDef.moveDef[0],fPhysObj.physObjDef.moveDef[1],fPhysObj.physObjDef.spread);
						break;
					case "pattern":
						NonAvatar(fPhysObj).startPatternMv(fPhysObj.physObjDef.moveDef[0],fPhysObj.physObjDef.moveDef[1]);
						break;
					default:
						break;
				}
			}
			addChild(fPhysObj);
			fPhysObj.x = pX;
			fPhysObj.y = pY;stage.stageHeight/2;
			fPhysObj.team = pTeam;
			physObjArray.push(fPhysObj);
			playerArray.push(fPhysObj);
		}
		private var monsterOriginX:Number = 850;
		private var monsterCounterArray:Array = new Array(0);//To time when the monsters appear
		private var monsterMax:uint;
		private var monsterCrnt:uint = 0;
		private var monsterArray:Array = new Array(0);
		private var lastTimeBoss:uint;
		private var bossDelay:uint = 2000;
		private function startLvl(){
			lvlTime = 0;
			startMonsterMaker();
		}
		private function startMonsterMaker(){
			monsterMax = lvlDefCrnt.monsterMax;
			monsterCrnt = 0;
			monsterCounterArray = new Array(0);
			var i:uint = 0;
			for(i=0;i<lvlDefCrnt.monsterArray.length;i++){
				var fMonsterHash:Object = lvlDefCrnt.monsterArray[i];
				var fCounter:Counter = new Counter(-1,-1,1,getGameTime);
				fCounter.setFreq(fMonsterHash["hFreqMin"],fMonsterHash["hFreqMax"])
				monsterCounterArray.push({hCounter:fCounter,hNum:0});
			}
		}
		private function monsterMaker(){
			var i:uint;
			var j:uint;
			if(monsterCrnt < monsterMax){
				for(i=0;i<monsterCounterArray.length;i++){
					if(lvlTime > lvlDefCrnt.monsterArray[i]["hArrive"]){//If past the arrive time of monster
						monsterCounterArray[i]["hCounter"].counterOn = true;
						monsterCounterArray[i]["hCounter"].counting();
						var fMonsterHash:Object = lvlDefCrnt.monsterArray[i];
						if(monsterCounterArray[i]["hNum"] < fMonsterHash["hNum"]){//If less than total monster count
							if(monsterCounterArray[i]["hCounter"].totalCount > 0){//If monster freq is up
								monsterCounterArray[i]["hNum"]++;
								var fYRatio:Number;
								if(fMonsterHash["hYCoordRatio"] is Function){
									fYRatio = fMonsterHash["hYCoordRatio"]();
								}
								else{
									fYRatio = fMonsterHash["hYCoordRatio"];
								}
								if(fMonsterHash["hGroup"]!=null){
									for(j=0;j<fMonsterHash["hGroup"]["hNum"];j++){
										monsterArray.push(createPhysObj(fMonsterHash["hGroup"]["hNameArray"][j%fMonsterHash["hGroup"]["hNameArray"].length], monsterOriginX+j*fMonsterHash["hGroup"]["hXInterval"],fYRatio*stage.stageHeight+j*fMonsterHash["hGroup"]["hYInterval"],"left","enemy"));
										monsterCrnt++;
										if(monsterCrnt >= monsterMax){
											return;
										}
									}
								}
								else{
									monsterArray.push(createPhysObj(fMonsterHash["hName"], monsterOriginX,fYRatio*stage.stageHeight,"left","enemy"));
									monsterCrnt++;
									if(monsterCrnt >= monsterMax){
										return;
									}
								}
							}
						}
					}
				}
			}
			else{
				if(bossOn){
					if(gameTime-lastTimeBoss>=bossDelay){
						bossOn = false;
						boss = createPhysObj(lvlDefCrnt.boss["hName"], stage.stageWidth,lvlDefCrnt.boss["hYCoordRatio"]*stage.stageHeight,"left","enemy",false);
					}
				}
			}
		}
		private function lvlMv(){
			for(var i:uint; i<physObjArray.length; i++){
				if(physObjArray[i]!=avatar && physObjArray[i].physObjCreator!=avatar){
					physObjArray[i].mvSpeed.addMvSpeed({hName:"lvlMv",hVelX:lvlDefCrnt.lvlSpeed,hAccX:0,hVelY:0,hAccY:0,hTier:10},"add");
				}
			}
		}
		//GAME LOOPS+++++++++++++++++++++++++++++++++++++++++++++++++++++
		private var lastTimeGameTime:Number = 0;
		private var gameTime:Number = 0;
		private var gameRunSpeed:Number = 1;
		private var lvlTime:Number = 0;
		private function gameTimeRun() {
			var fTimePassed:uint = getTimer()-lastTimeGameTime;
			lastTimeGameTime+=fTimePassed;
			gameTime += fTimePassed*gameRunSpeed;
			lvlTime += fTimePassed*gameRunSpeed;
		}
		public function getGameTime():Number{
			return gameTime;
		}
		private function runPhysObjLoops(){
			var i:int=0;
			for(i=0;i<physObjArray.length;i++){
				if(!physObjArray[i].deathOn){
					if(physObjArray[i] is NonAvatar){
						if(physObjArray[i].patternMvOn){
							physObjArray[i].patternMv();
						}
					}
					else if(physObjArray[i] is Avatar){
						physObjArray[i].playerActions();
					}
					physObjArray[i].physObjLoop();
				}
			}
		}
		private function gameLoop(e:Event){
			var i:uint = 0;
			var j:uint = 0;
			gameTimeRun();
			monsterMaker();
			runPhysObjLoops();
			if(avatar){
				for(i=0;i<avatarArray.length;i++){
					avatarArray[i].startMouseAim("DogEye",9,-24.65);
				}
			}
			if(avatar && mouseDownOn){
				avatar.skillEquipArray[avatar.skillEquipCrnt][1].counterOn = true;
				//trace(avatar.skillEquipArray[avatar.skillEquipCrnt][1].totalCount);
				for(i=0; i<avatar.skillEquipArray[avatar.skillEquipCrnt][1].totalCount; i++){
					createAO(avatar.skillEquipArray[avatar.skillEquipCrnt][0], avatar, i);
				}
			}
			if(avatar && !mouseDownOn){
				avatar.skillEquipArray[avatar.skillEquipCrnt][1].counterOn = false;
			}
			for(i=0; i<playerArray.length; i++){
				if(playerArray[i] != avatar){
					if(playerArray[i].skillEquipArray.length>0){
						playerArray[i].skillEquipArray[playerArray[i].skillEquipCrnt][1].counterOn = true;
						for(j=0; j<playerArray[i].skillEquipArray[playerArray[i].skillEquipCrnt][1].totalCount; j++){
							createAO(playerArray[i].skillEquipArray[playerArray[i].skillEquipCrnt][0], playerArray[i], j);
						}
					}
				}
			}
			Collision.testAllCollision(physObjArray,this);
			
			for(i=0;i<physObjArray.length;i++){
				physObjArray[i].damage.aFTSetDmg();
			}
			for(i=0;i<physObjArray.length;i++){
				physObjArray[i].damage.aFTHitDmg();
			}
			removeOutOfBounds();
			checkDeath(physObjArray);
		}
		private var boundDeathLeeway:Number = 200;
		private function removeOutOfBounds(){
			var i:uint=0;
			for(i=0;i<physObjArray.length;i++){
				switch(physObjArray[i].physObjDef.physObjType){
					case "player":
						if(physObjArray[i].x-physObjArray[i].crntGraphic.width/2<0-boundDeathLeeway){
							physObjArray[i].deathOn = true;
						}
						break;
					case "bullet":
						if(physObjArray[i].x+physObjArray[i].crntGraphic.width/2>stage.stageWidth+boundDeathLeeway || physObjArray[i].x-physObjArray[i].crntGraphic.width/2<0-boundDeathLeeway || physObjArray[i].y+physObjArray[i].crntGraphic.height/2<0-boundDeathLeeway){
							physObjArray[i].deathOn = true;
						}
						break;
					default:
						break;
				}
			}
		}
		private var popUpBoxArray:Array = new Array(0);
		private var lvlFinishOn:Boolean = false;
		private function checkDeath(pArray:Array){
			var i:int = 0;
			for(i=0; i<pArray.length; i++){
				if(pArray[i].deathOn){
					var fPhysObj:PhysObj = pArray[i];
					ArrayHelper.findAndRemove(physObjArray, fPhysObj, 1);
					ArrayHelper.findAndRemove(playerArray, fPhysObj, 1);
					ArrayHelper.findAndRemove(bulletArray, fPhysObj, 1);
					ArrayHelper.findAndRemove(avatarArray, fPhysObj, 1);
					ArrayHelper.findAndRemove(monsterArray, fPhysObj, 1);
					if(monsterArray.length == 0 && monsterCrnt >= monsterMax && !boss && !bossOn && !lvlFinishOn){
						if(lvlDefCrnt.boss == null){
							startLevelFinish();
						}
						else{
							bossOn = true;
							lastTimeBoss = gameTime;
						}
					}
					if(this.contains(fPhysObj)){
						removeChild(fPhysObj);
					}
					
					i--;
				}
			}
			if(avatar){
				if(avatar.deathOn){
					reset();
					return;
				}
			}
			if(boss){
				if(boss.deathOn && !lvlFinishOn){
					startLevelFinish();
					//reset();
				}
			}
		}
		private function startLevelFinish(){
			lvlFinishOn = true;
			var fLevelFinishPopUpBox:PopUpBox = new PopUpBox();
			var fLevelFinishBox:LevelFinishBox = new LevelFinishBox();
			fLevelFinishPopUpBox.x = stage.stageWidth/2;
			fLevelFinishPopUpBox.y = 0;
			addChild(fLevelFinishPopUpBox);
			fLevelFinishPopUpBox.start(fLevelFinishBox,-1,[0,0,2*fLevelFinishBox.height*(1000/500),-2*fLevelFinishBox.height*Math.pow(1000/500,2),500, 
														0,0,0,0,2000
														//0,0,-2*fLevelFinishBox.height*(1000/500),2*fLevelFinishBox.height*Math.pow(1000/500,2),500
														],getTimer);
			fLevelFinishPopUpBox.setStoreArray(popUpBoxArray);
			
			fLevelFinishBox.txtDamage.text = "HIIII";
		}
		private function reset(){
			avatar = null;
			physObjArray = new Array(0);
			playerArray = new Array(0);
			bulletArray = new Array(0);
			avatarArray = new Array(0);
			monsterArray = new Array(0);
			monsterCrnt = 0;
			monsterMax = 0;
			monsterCounterArray = new Array(0);
			boss = null;
			stage.removeEventListener(MouseEvent.CLICK, checkMainMenuMouse);
			stage.removeEventListener(MouseEvent.MOUSE_DOWN, checkMouseDown);
			stage.removeEventListener(MouseEvent.MOUSE_UP, checkMouseUp);
			//stage.addEventListener(MouseEvent.MOUSE_MOVE, checkMouse);
			removeEventListener(Event.ENTER_FRAME, gameLoop);
			initiateGame();
			lvlFinishOn = false;
			
		}
		public static function getMain():Main{
			return main;
		}
		//public function get mouseX
		/*
		private function initiateGame(){
			stage.frameRate = 30;
			stage.scaleMode = StageScaleMode.NO_BORDER;
			stage.focus = stage;
			pressSpaceOST.y = 75;

			keyboardTesterInputHash = {hPlayer0:{hBlock:Z_CODE,hJump:X_CODE,hSkill:C_CODE,hNormal:V_CODE,hSpecial:B_CODE,hSelect:V_CODE,hDeselect:Z_CODE,hLeft:LEFT_ARROW_CODE,hUp:UP_ARROW_CODE,hRight:RIGHT_ARROW_CODE,hDown:DOWN_ARROW_CODE},
									   hPlayer1:{hBlock:Q_CODE,hJump:W_CODE,hSkill:E_CODE,hNormal:R_CODE,hSpecial:T_CODE,hSelect:R_CODE,hDeselect:Q_CODE,hLeft:FOUR_CODE,hUp:EIGHT_CODE,hRight:SIX_CODE,hDown:FIVE_CODE}
									  };
			loadSettings();//Replaces keyboardTesterInputHash
			difficultyMenu.gotoAndStop(difficulty);
			if(musicOn){
				soundMenu.musicSwitch.gotoAndStop("musicOn");
			}
			else{
				soundMenu.musicSwitch.gotoAndStop("musicOff");
			}
			if(soundOn){
				soundMenu.soundSwitch.gotoAndStop("soundOn");
			}
			else{
				soundMenu.soundSwitch.gotoAndStop("soundOff");
			}
			
			keyboardTesterArray.push(new KeyboardTester(keyboardTesterInputHash.hPlayer0,stage));
			keyboardTesterArray.push(new KeyboardTester(keyboardTesterInputHash.hPlayer1,stage));

			//used for GOL
			keyVarHash0 = {left:function(){return keyboardTesterArray[0].getKeyOnHash().hLeft},
							up:function(){return keyboardTesterArray[0].getKeyOnHash().hUp},
							right:function(){return keyboardTesterArray[0].getKeyOnHash().hRight},
							down:function(){return keyboardTesterArray[0].getKeyOnHash().hDown},
							choose:function(){return keyboardTesterArray[0].getKeyOnHash().hNormal}
						};
			keyVarHash1 = {left:function(){return keyboardTesterArray[1].getKeyOnHash().hLeft},
							up:function(){return keyboardTesterArray[1].getKeyOnHash().hUp},
							right:function(){return keyboardTesterArray[1].getKeyOnHash().hRight},
							down:function(){return keyboardTesterArray[1].getKeyOnHash().hDown},
							choose:function(){return keyboardTesterArray[1].getKeyOnHash().hNormal}
						};
			keyVarHash2 = {left:function(){return keyboardTesterArray[0].getKeyOnHash().hLeft},
							up:function(){return keyboardTesterArray[0].getKeyOnHash().hUp},
							right:function(){return keyboardTesterArray[0].getKeyOnHash().hRight},
							down:function(){return keyboardTesterArray[0].getKeyOnHash().hDown},
							choose:function(){return spaceKeyPressOn}
						};
			startGameMenu();
			stage.addEventListener(KeyboardEvent.KEY_DOWN,keyDownFunction);
			stage.addEventListener(KeyboardEvent.KEY_UP,keyUpFunction);
		}
		//TRANSITION++++++++++++++++++++++++++++++++++++++++++++++++++++
		public function createTransition(pTransitionMidFunc:Function,pTransitionPostGameMode:String="battleArea"){
			if(transitionOn){
				removeTransition();
			}
			if(!transitionOn){
				transitionOn = true;
				gameMode = "transition";
				transitionPostGameMode = pTransitionPostGameMode;
				transitionMidFunc=pTransitionMidFunc;
				if(!Boolean(transitionBG)){
					transitionBG = new TransitionBG();
				}
				if(transitionBG.parent==null){
					this.addChild(transitionBG);
					transitionBG.width = stage.stageWidth;
					transitionBG.height = stage.stageHeight;
					transitionBG.x=0;
					transitionBG.y=stage.stageHeight;
				}
				transitionBG.alpha = 0;
				transitionBG.visible=true;
				setChildIndex(transitionBG,numChildren-1);
				addEventListener(Event.ENTER_FRAME, transitionTime);
				if(bGSoundEffect!=null){
					bGSoundEffect.startFadeOutSoundEffect(transDuration/2);
				}
				lastTimeTrans = getTimer();
				keyDownOn = false;//Turn off keys
			}
		}
		private function transitionTime(e:Event){
			//start by turn light -> dark 
			if(getTimer()-lastTimeTrans<transDuration/2){
				transitionBG.alpha = (getTimer()-lastTimeTrans)/(transDuration/2);
			}
			//end by turn dark -> light
			else if(getTimer()-lastTimeTrans>=transDuration/2 && getTimer()-lastTimeTrans<=transDuration){
				//Call the function
				if(!transitionMidFuncOn){
					transitionMidFunc();
					transitionMidFuncOn = true;
					
					if(transitionBG.parent==null){//In case it is removed by transitionMidFunc() (e.g. unloadAll, reset, etc.)
						this.addChild(transitionBG);
						transitionBG.width = stage.stageWidth;
						transitionBG.height = stage.stageHeight;
						transitionBG.x=0;
						transitionBG.y=stage.stageHeight;
						transitionBG.visible = true;
					}
					//Make sure transitionBG is on top
					var topPosition:int = this.numChildren - 1;
					if(topPosition>=0){
						this.setChildIndex(transitionBG, topPosition);
					}
				}
				transitionBG.alpha = 1-(getTimer()-lastTimeTrans-transDuration/2)/(transDuration/2);
			}
			else if(getTimer()-lastTimeTrans>transDuration){
				removeTransition();
			}
		}
		private function removeTransition(){
			transitionOn = false;
			if(gameMode == "transition"){
				gameMode = transitionPostGameMode;
			}
			transitionMidFuncOn = false;
			transitionBG.visible=false;
			removeEventListener(Event.ENTER_FRAME, transitionTime);
			keyDownOn = true;//Turn keys back on
		}
		*/
	}
}