﻿package {
	import flash.display.*;
	import flash.events.*;
	import flash.utils.getTimer;
	import flash.utils.getDefinitionByName;
	import flash.utils.getQualifiedClassName;
	import flash.geom.Point;
	import flash.media.Sound;
	import flash.media.SoundTransform;
	import flash.geom.ColorTransform;
	import flash.filters.*;
	import fl.motion.Color;
	
	public class Collision extends MovieClip{
		public function Collision(){
		}
//		private function getCurrentGraphicSearchArray(pMC:MovieClip,pArray:Array,pOpposite:Boolean=false):Array{//pArray=String Array of class names of children of pMC (used in Game's testCollision)
//			//If pOpposite==true, return every graphic EXCEPT for the ones that match in pArray
//			var fGraphicArray = new Array(0);
//			if(pMC==null){
//				return fGraphicArray;
//			}
//			for(var i:uint=0;i<pArray.length;i++){
//				for(var j:uint=0;j<pMC.numChildren;j++){
//					if(!pOpposite){//For matching
//						if(getQualifiedClassName(pMC.getChildAt(j))==pArray[i]){
//							fGraphicArray.push(pMC.getChildAt(j));
//						}
//					}
//					else{//For not matching
//						if(getQualifiedClassName(pMC.getChildAt(j))!=pArray[i]){
//							fGraphicArray.push(pMC.getChildAt(j));
//						}
//					}
//				}
//			}
//			return fGraphicArray;
//		}
		public static function getHitGraphic(pMC:MovieClip,pHitRules:Array):Array{
			if(pHitRules.length==0){
				return [{hMC:pMC,hDmgRatio:1}];
			}
			var fGraphicArray:Array = new Array(0);
			var i:uint=0;
			var j:uint=1;
			for(i=0;i<pMC.numChildren;i++){
				var fExceptionOn:Boolean = false;
				for(j=1;j<pHitRules.length;j++){
					if(getQualifiedClassName(pMC.getChildAt(i))==pHitRules[j]["hName"]){
						fExceptionOn = true;
						if(pHitRules[j]["hHitOn"]){
							fGraphicArray.push({hMC:pMC.getChildAt(i),hDmgRatio:pHitRules[j]["hDmgRatio"],hSkillName:pHitRules[j]["hSkillName"]});
						}
					}
				}
				if(!fExceptionOn){
					if(pHitRules[0]["hHitOn"]){
						if(pMC.getChildAt(i)!=null){
							fGraphicArray.push({hMC:pMC.getChildAt(i),hDmgRatio:pHitRules[0]["hDmgRatio"],hSkillName:pHitRules[0]["hSkillName"]});
						}
					}
				}
			}
			return fGraphicArray;
		}
		public static function testCollision(pAttacker:PhysObj,pVictim:PhysObj,pCommonParent:MovieClip):Object{
			if (!pAttacker.deathOn && !pVictim.deathOn && !pAttacker.invOn && !pVictim.invOn) {
				if(PhysObj.compareTeams(pAttacker,pVictim)){
					if(pAttacker.skill.getAOHitOn()){
						var fAtkGraphic:Array = getHitGraphic(pAttacker.crntGraphic,pAttacker.physObjDef.dmgRules);
						var fVicGraphic:Array = getHitGraphic(pVictim.crntGraphic,pVictim.physObjDef.hitRules);
						var i:uint=0;
						for(var m:uint=0;m<fAtkGraphic.length;m++){
							for(var n:uint=0;n<fVicGraphic.length;n++){
								if(fAtkGraphic[m]["hSkillName"] is String && PixelPerfectCollisionDetection.isColliding(fAtkGraphic[m]["hMC"],fVicGraphic[n]["hMC"],pCommonParent,true,0,0,0)){
									return {hHit:true,hDmgRatio:fAtkGraphic[m]["hDmgRatio"]*fVicGraphic[n]["hDmgRatio"],hSkillName:fAtkGraphic[m]["hSkillName"]};
								}
							}
						}
					}
				}
			}
			return {hHit:false,hDmgRatio:0,hSkillName:null};
		}
		public static function testAllCollision(pPOArray:Array,pCommonParent:MovieClip):Boolean{
			var fHitOcc:Boolean = false;
			for (var i:int = 0; i < pPOArray.length; i++) {
				for (var j:int = i+1; j < pPOArray.length; j++) {
					var fAttacker:PhysObj = pPOArray[i];
					var fVictim:PhysObj = pPOArray[j];
					for(var k:int = 0; k < 2; k++){
						if(k==1){//Switch attacker and victim in the 2nd iteration
							fAttacker = pPOArray[j];
							fVictim = pPOArray[i];
						}
						var fTestCollision:Object = testCollision(fAttacker,fVictim,pCommonParent);
						if(fTestCollision["hHit"]){
							fVictim.damage.addAFT(fAttacker,fTestCollision["hSkillName"],fTestCollision["hDmgRatio"]);
						}
						else{
							fVictim.damage.removeAFTContact(fAttacker);
						}
					}
				}
			}
			return fHitOcc;
		}
	}
}