﻿package{
	import flash.display.*;
	
	public class KeyCodeConverter{
		public function KeyCodeConverter(){
		}
		public static function convertKeyCodeToString(pKeyCode:Number):String{
			//For alphabet and numbers
			if((pKeyCode>=65 && pKeyCode<=90) ||
			   (pKeyCode>=48 && pKeyCode<=57)){
				
				return String.fromCharCode(pKeyCode);
			}
			else{
				//For Numpad #'s
				if(pKeyCode>=96 && pKeyCode<=105){
					return "Numpad " + String(pKeyCode - 96);
				}
				//For Numpad Misc.
				switch(pKeyCode){
					case 106:
						return "Numpad *";
					case 107:
						return "Numpad +";
					case 109:
						return "Numpad -";
					case 110:
						return "Numpad .";
					case 111:
						return "Numpad /";
					default:
						break;
				}
				//The F#'s
				if(pKeyCode>=112 && pKeyCode<=126){
					return "F" + String(pKeyCode - 111);
				}
				//Everything else
				switch(pKeyCode){
			   		case 8:
						return "Backspace";
					case 9:
						return "Tab";
					case 13:
						return "Enter";
					case 27:
						return "Esc";
					case 32:
						return "Spacebar";
					case 16:
						return "Shift";
					case 17:
						return "Ctrl";
					case 20:
						return "Caps Lock";
					case 33:
						return "Page Up";
					case 34:
						return "Page Down";
					case 35:
						return "End";
					case 36:
						return "Home";
					case 37:
						return "Left Arrow";
					case 38:
						return "Up Arrow";
					case 39:
						return "Right Arrow";
					case 40:
						return "Down Arrow";
					case 45:
						return "Insert";
					case 46:
						return "Delete";
					case 144:
						return "Num Lock";
					case 145:
						return "ScrLk";
					case 19:
						return "Pause/Break";
					case 186:
						return ";:";
					case 187:
						return "=+";
					case 189:
						return "-_";
					case 191:
						return "/?";
					case 192:
						return "`~";
					case 219:
						return "[{";
					case 220:
						return "\|";
					case 221:
						return "]}";
					case 222:
						return "\"";
					case 188:
						return ",<";
					case 190:
						return ".>";
					default:
						break;
				}
			}
			return "N/A";
		}
	}
}