﻿package {
	import flash.display.*;
	import flash.events.*;
	import flash.utils.getTimer;
	import flash.geom.Point;
	import flash.text.*;
	import flash.net.SharedObject;
	import flash.net.URLRequest;
	import flash.net.navigateToURL;
	import flash.geom.ColorTransform;//For when selected same char
	import flash.display.LoaderInfo;
	import flash.ui.ContextMenu;
	//import flash.ui.ContextMenu.hideBuiltInItems;
	import flash.utils.getQualifiedClassName;
	
	public dynamic class Main extends MovieClip {
		private static var main:Main;
		
		private var intro:Intro;
		
		private var trainingOn:Boolean = false;//If in training mode
		private var cpuTrainingOn:Boolean = false;//If training with CPU
		
		private var bGSound:SoundEffect;
		private var bGSound_Array:Array = new Array(0);
		
		//private var transitionBG:TransitionBG;
		private var transitionOn:Boolean = false;
		private var transitionPostGameMode:String;
		private var transitionMidFunc:Function;
		private var transitionMidFuncOn:Boolean = false;
		private var transDuration:uint = 1000;
		
		static const KEY_1:uint = 49;
		static const KEY_2:uint = 50;
		static const KEY_3:uint = 51;
		static const KEY_4:uint = 52;
		static const KEY_W:uint = 87;
		static const KEY_A:uint = 65;
		static const KEY_S:uint = 83;
		static const KEY_D:uint = 68;
		static const KEY_Q:uint = 81;
		static const KEY_E:uint = 69;
		static const KEY_SPACE:uint = 32;
		
		
		private var mouseDownOn:Boolean = false;
		private var mouseFirstTimePressOn:Boolean = true;
		
		private var lvlDefCrnt:LvlDef;
		
		private var _ptBStorageArray:Array = new Array(0);
		
		public function get ptBStorageArray():Array{
			return _ptBStorageArray;
		}
		public function Main():void{
			main = this;
			addEventListener(Event.ADDED_TO_STAGE, stageAddedFunc);
		}
		private function stageAddedFunc(e:Event){
			stage.frameRate = 30;
			stage.scaleMode = StageScaleMode.NO_BORDER;
			stage.focus = stage;
			stage.quality = "high";
			
//			for(i=0; i<this.numChildren; i++){
//				switch(this.getChildAt(i)){
//					case mochiAdBG:
//						break;
//					default:
//						removeChild(this.getChildAt(i));
//						i--;
//				}
//			}
			
			var rightClick:ContextMenu = new ContextMenu();//create a new right click menu called rightClick
			rightClick.hideBuiltInItems();//hide the built in options of the right click menu
			this.contextMenu = rightClick;//make the neccesary changes to the right click menu


//			if (testSiteLock()) {
//				trace("Wrong site!");
//			}
//			else{
				addEventListener(Event.ENTER_FRAME, checkAdEnd);
//			}
		}
		private function checkAdEnd(e:Event){
			//if(currentLabel == "endAd"){
				removeEventListener(Event.ENTER_FRAME, checkAdEnd);
				preloaderStartFunc();
			//}
		}
		private function preloaderStartFunc(){
			intro = new Intro(stage);
			intro.startIntro([new IntroMC()],null,initiateGame);
			addChild(intro);
			intro.x = 0;//stage.stageWidth/2;
			intro.y = 0;//stage.stageHeight/2;
			addEventListener(MouseEvent.CLICK, checkIntro);
//			preloader.loadScreen.removeEventListener(MouseEvent.CLICK, checkMouseStartGame);
//			preloader.loadScreen.stop();
/*
			var fTransFunc:Function = function(){
				for(var i:uint=0; i<numChildren; i++){
					removeChildAt(i);
					i--;
				}
				//gotoAndStop("startGame");
				
				//INITIATE CLASS VAR (Must do here since custom classes are not loaded until after the preloader completes)
				transitionBG = new TransitionBG();
				titleScreen = new TitleScreen();
				
				//Need to add again since change frames
				this.addChild(transitionBG);
				transitionBG.width = stage.stageWidth;
				transitionBG.height = stage.stageHeight;
				transitionBG.x=0;
				transitionBG.y=stage.stageHeight;
				
				initiateGame();
			}
			createTransition(fTransFunc,null);
			*/
			lvlDefCrnt = new LvlDef();
			lvlDefCrnt.setLvlDef("1");
			monsterOriginX = stage.stageWidth - 35;
		}
		private function checkIntro(e:MouseEvent):void {
			switch(e.target) {
				case intro.currentIntroMC.btnExit:
					intro.currentIntroMC.gotoAndStop("end");
					break;
			}
		}
		private var titleScreen:TitleScreen;
		private var keyboardTesterInputHash:Object;
		private var keyboardTesterArray:Array = new Array(0);
		private function initiateGame() {
			removeEventListener(MouseEvent.CLICK, checkIntro);
			removeChild(intro);
			titleScreen = new TitleScreen();
			addChild(titleScreen);
			
			//bGSound = new SoundEffect("LvlSong", 1, getGameTime, bGSound_Array);
			
			keyboardTesterInputHash = {hPlayer0:{hSkillChangeB:KEY_Q,hSkillChangeF:KEY_E,hSpecial:KEY_SPACE,hSkill1:KEY_1,hSkill2:KEY_2,hSkill3:KEY_3,hSkill4:KEY_4,hUp:KEY_W,hLeft:KEY_A,hDown:KEY_S,hRight:KEY_D}
									   //hPlayer1:{hBlock:Q_CODE,hJump:W_CODE,hSkill:E_CODE,hNormal:R_CODE,hSpecial:T_CODE,hSelect:R_CODE,hDeselect:Q_CODE,hLeft:FOUR_CODE,hUp:EIGHT_CODE,hRight:SIX_CODE,hDown:FIVE_CODE}
									  };
			keyboardTesterArray.push(new KeyboardTester(keyboardTesterInputHash.hPlayer0,stage));
			//keyboardTesterArray.push(new KeyboardTester(keyboardTesterInputHash.hPlayer1,stage));

			stage.addEventListener(MouseEvent.CLICK, checkMainMenuMouse);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, checkMouseDown);
			stage.addEventListener(MouseEvent.MOUSE_UP, checkMouseUp);
			//stage.addEventListener(MouseEvent.MOUSE_MOVE, checkMouse);
			addEventListener(Event.ENTER_FRAME, gameLoop);
		}
		private var avatar:PhysObj;
		private var boss:PhysObj;
		private var bossOn:Boolean = false;
		private var avatarArray:Array = new Array(0);
		private var bulletArray:Array = new Array(0);
		private var playerArray:Array = new Array(0);
		private var physObjArray:Array = new Array(0);
		private var _mouseX:Number = 0;
		private var _mouseY:Number = 0;
		public function getMouseX():Number{
			return mouseX;
		}
		public function getMouseY():Number{
			return mouseY;
		}

		private function checkMouseDown(e:MouseEvent){
			mouseDownOn = true;
		}
		private function checkMouseUp(e:MouseEvent){
			mouseDownOn = false;
			mouseFirstTimePressOn = true;
		}
		private var crntBG:Background = new Background();
		private var crntFG:Background = new Background();
		private function checkMainMenuMouse(e:MouseEvent) {
			switch(e.target) {
				case titleScreen.btnStartGame:
					reset();
					removeChild(titleScreen);
					crntBG.createBackground(lvlDefCrnt.bGArray,0,stage.stageWidth,stage.stageHeight,stage);
					crntBG.startAutoScroll(getGameTime);
					addChild(crntBG);
					if(lvlDefCrnt.foregroundArray.length>0){
						crntFG.createBackground(lvlDefCrnt.foregroundArray,0,stage.stageWidth,stage.stageHeight,stage);
						crntFG.startAutoScroll(getGameTime);
						addChild(crntFG);
					}
					createPhysObj("Onion",stage.stageWidth/2,stage.stageHeight/2,"right","avatar",false,true);
					
					startLvl();
					stage.focus = stage;
					//boss = createPhysObj("Mom",stage.stageWidth,stage.stageHeight,"left","enemy",false);
					break;
			}
			if(e.target is ClickToContinueBtn){
				reset();
//				if(
//				createAO("Bark", avatar);
			}
		}
		private function createPhysObj(pName:String=null, pX:Number=0,pY:Number=0, pDirectionFacing:String=null, pTeam:String=null,pLvlMvOn:Boolean=true, pAvatarOn:Boolean=false, pOriginX:Number=0,pOriginY:Number=0,pNumMultiple:Number=0,pMouseAimOn:Boolean=false,pCreator:PhysObj=null):PhysObj{
			var fPhysObj:PhysObj;
			var fDef:Object;
			if(pAvatarOn){
				avatar = new PhysObj(pName,getGameTime,pCreator);
				fPhysObj = avatar;
				avatarArray.push(avatar);
				fDef = Clone.doClone(avatar.physObjDef.control);
				fDef["hKeyboardTester"] = keyboardTesterArray[0];
				avatar.addControl("primary","keyboard",fDef,{hTierNum:0,hType:"add"});
				avatar.keyboard = keyboardTesterArray[0];
				//fPhysObj.addControl("primary","linear",{hXDist:mouseX-fPhysObj.x,hYDist:mouseY-fPhysObj.y,hVel:100,hAcc:0,hSpread:0,hFixedSpread:0});
				if(pDirectionFacing == "left"){
					fPhysObj.setDirectionFacing("left");
				}
				if(pDirectionFacing == "right"){
					fPhysObj.x = pX + pOriginX + avatar.physObjDef.initialDisp["hX"];
				}
				else{
					fPhysObj.x = pX - pOriginX - avatar.physObjDef.initialDisp["hX"];
				}
				fPhysObj.y = pY + pOriginY + avatar.physObjDef.initialDisp["hY"];
			}
			else{
				fPhysObj = new PhysObj(pName,getGameTime,pCreator);
				if(pDirectionFacing == "left"){
					fPhysObj.setDirectionFacing("left");
				}
				if(pDirectionFacing == "right"){
					fPhysObj.x = pX + pOriginX + fPhysObj.physObjDef.initialDisp["hX"];
				}
				else{
					fPhysObj.x = pX - pOriginX - fPhysObj.physObjDef.initialDisp["hX"];
				}
				fPhysObj.y = pY + pOriginY + fPhysObj.physObjDef.initialDisp["hY"];

				fDef = Clone.doClone(fPhysObj.physObjDef.moveDef["hDef"]);
				switch(fPhysObj.physObjDef.moveDef["hType"]){
					case "linear":
						var fSpreadAngle:Number = 0;
						if(fPhysObj.physObjDef.multipleSpread.length > pNumMultiple){
							fSpreadAngle = fPhysObj.physObjDef.multipleSpread[pNumMultiple];
						}
						var fPhysObjY:Number = fPhysObj.y;
						if(fPhysObj.mCAlignXY["hY"]=="mid"){//Fix for graphic alignment
							//fPhysObjY = fPhysObj.y-fPhysObj.crntGraphicStandHeight/2;
						}						
						fDef["hFixedSpread"] = fSpreadAngle;
						if(pMouseAimOn){
							fDef["hXDist"] = mouseX-fPhysObj.x;
							fDef["hYDist"] = mouseY-fPhysObj.y;
							
							//fPhysObj.addControl("primary","linear",{hVel:fPhysObj.physObjDef.moveDef[0],hAcc:fPhysObj.physObjDef.moveDef[1],hSpread:fPhysObj.physObjDef.spread,hFixedSpread:fSpreadAngle,hTravelTime:fPhysObj.physObjDef.linearMv["hTravelTime"],hMinDist:fPhysObj.physObjDef.linearMv["hMinDist"],hMaxDist:fPhysObj.physObjDef.linearMv["hMaxDist"]},{hTierNum:0,hType:"add"});
							//fPhysObj.linearMvCoord(mouseX-fPhysObj.x,mouseY-fPhysObjY,fPhysObj.physObjDef.moveDef[0],fPhysObj.physObjDef.moveDef[1],fPhysObj.physObjDef.spread, fSpreadAngle);
						}
						else{
							fDef["hXDist"] = avatar.x-fPhysObj.x;
							fDef["hYDist"] = avatar.y-fPhysObj.y;
							//fPhysObj.addControl("primary","linear",{hXDist:avatar.x-fPhysObj.x,hYDist:avatar.y-fPhysObjY,hVel:fPhysObj.physObjDef.moveDef[0],hAcc:fPhysObj.physObjDef.moveDef[1],hSpread:fPhysObj.physObjDef.spread,hFixedSpread:0,hTravelTime:fPhysObj.physObjDef.linearMv["hTravelTime"],hMinDist:fPhysObj.physObjDef.linearMv["hMinDist"],hMaxDist:fPhysObj.physObjDef.linearMv["hMaxDist"]},{hTierNum:0,hType:"add"});
							//fPhysObj.linearMvCoord(avatar.x-fPhysObj.x,avatar.y-avatar.height/2-fPhysObjY,fPhysObj.physObjDef.moveDef[0],fPhysObj.physObjDef.moveDef[1],fPhysObj.physObjDef.spread);
						}
						fPhysObj.addControl("primary","linear",fDef,{hTierNum:0,hType:"add"});
						break;
					case "pattern":
						fDef["hXInverseOn"] = pDirectionFacing=="left";
						fPhysObj.addControl("primary","pattern",fDef,{hTierNum:0,hType:"add"});
//						fPhysObj.addControl("primary","pattern",{hXInverseOn:(pDirectionFacing=="left"),hXMvArray:fPhysObj.physObjDef.moveDef[0],hYMvArray:fPhysObj.physObjDef.moveDef[1]},{hTierNum:0,hType:"add"});
						break;
					default:
						break;
				}
			}
			addChild(fPhysObj);

			fPhysObj.team = pTeam;
//			if(pCreator==null){
//				fPhysObj.physObjCreator = fPhysObj;
//			}
//			else{
//				fPhysObj.physObjCreator = pCreator;
//			}
			if(pLvlMvOn){
//			if(fPhysObj!=avatar && fPhysObj.physObjCreator!=avatar && fPhysObj!=boss && fPhysObj.physObjCreator!=boss){
				//fPhysObj.addControl("lvlMv","pattern",{hXInverseOn:true,hXMvArray:[-lvlDefCrnt.lvlSpeed,null,0,500],hYMvArray:[0,null,0,0]},{hTierNum:10,hType:"add"});
			}
			if (fPhysObj.team != "avatar" && fPhysObj.physObjDef.physObjType == "player") {
				monsterArray.push(fPhysObj);
			}
			physObjArray.push(fPhysObj);
			playerArray.push(fPhysObj);
			bulletArray.push(fPhysObj);
			return fPhysObj;
		}
		private function createAO(pName:String, pPlayer:PhysObj, pNumMultiple:uint=0, pCounter:Counter=null){
			var fMouseAimOn:Boolean = false;
			var fTestPODef:PhysObjDef = new PhysObjDef();//If no AO is created, but still an effect (recoil, inv, etc.)
			fTestPODef.setPhysObjDef(pName);
			if(fTestPODef.startFunc!=null)fTestPODef.startFunc(pPlayer);
			if (pCounter != null) pCounter.setFreq(fTestPODef.cooldown, fTestPODef.cooldown);
			if(pPlayer == avatar || fTestPODef.mouseAimOn){
				fMouseAimOn = true;
			}
			var fRecoil:Object;
			var fInv:Number;
			if(fTestPODef.mCName != null){
				var fDirectionFacing:String;
				if(fTestPODef.faceMouseDirectionOn){
					if(mouseX < avatar.x){
						fDirectionFacing = "left";
					}
					else{
						fDirectionFacing = "right";
					}
				}
				else{
					fDirectionFacing = pPlayer.directionFacing;
				}
				var fXDisp:Number = 0;
				var fYDisp:Number = 0;
				if(fTestPODef.initialDisp["hMouseXOn"] is Boolean && fTestPODef.initialDisp["hMouseXOn"]){
					if(mouseX > pPlayer.x + fTestPODef.initialDisp["hMaxLimX"])fXDisp = pPlayer.x + fTestPODef.initialDisp["hMaxLimX"];
					else if(mouseX < pPlayer.x + fTestPODef.initialDisp["hMinLimX"])fXDisp = pPlayer.x + fTestPODef.initialDisp["hMinLimX"];
					else fXDisp = mouseX;
				}
				else if(fTestPODef.dispPlayerReferenceOn["hXOn"])fXDisp = pPlayer.x;
				
				if(fTestPODef.initialDisp["hMouseYOn"] is Boolean && fTestPODef.initialDisp["hMouseYOn"]){
					if(mouseY > pPlayer.y + fTestPODef.initialDisp["hMaxLimY"])fYDisp = pPlayer.y + fTestPODef.initialDisp["hMaxLimY"];
					else if(mouseY < pPlayer.y + fTestPODef.initialDisp["hMinLimY"])fYDisp = pPlayer.y + fTestPODef.initialDisp["hMinLimY"];
					else fYDisp = mouseY;
				}
				else if(fTestPODef.dispPlayerReferenceOn["hYOn"])fYDisp = pPlayer.y;
				var fPO:PhysObj = createPhysObj(pName, fXDisp, fYDisp, fDirectionFacing, pPlayer.team, pPlayer != avatar && pPlayer != boss, false, pPlayer.physObjDef.bulletOrigin["hX"], pPlayer.physObjDef.bulletOrigin["hY"], pNumMultiple, fMouseAimOn, pPlayer);
				if(fPO.physObjDef.startFunc!=null)fPO.physObjDef.startFunc(pPlayer);
				fRecoil = fPO.physObjDef.recoil;
				fInv = fPO.physObjDef.inv;
			}
			else{
				fRecoil = fTestPODef.recoil;
				fInv = fTestPODef.inv;
			}
			if(fRecoil != null){
				var fDef:Object = Clone.doClone(fRecoil["hDef"]);
					if(fRecoil["hType"]=="linear"){
						if(fMouseAimOn){
							fDef["hXDist"] = mouseX-pPlayer.x;
							fDef["hYDist"] = mouseY-pPlayer.y;
						}
						else{
							fDef["hXDist"] = avatar.x-pPlayer.x;
							fDef["hYDist"] = avatar.y-pPlayer.y;
						}
						pPlayer.addControl(fRecoil["hName"],"linear",fDef,fRecoil["hTier"],fRecoil["hDuration"]);
					}
					else{
						fDef["hXInverseOn"] = pPlayer.directionFacing=="left";
						pPlayer.addControl(fRecoil["hName"],fRecoil["hType"],fDef,fRecoil["hTier"],fRecoil["hDuration"]);
					}
					//pPlayer.mvSpeed.mvSpeedOn = false;
				//}
			}
			if(fInv>0){
				pPlayer.startInv(fInv);
			}
		}
		private var monsterOriginX:Number;
		private var monsterCounterArray:Array = new Array(0);//To time when the monsters appear
		private var monsterMax:uint;
		private var monsterCrnt:uint = 0;
		private var monsterArray:Array = new Array(0);
		private var lastTimeBoss:uint;
		private var bossDelay:uint = 2000;
		private var lifeBar:LifeBar_MC;
		private var lifeBarNode_Array:Array;
		private var enemyLifeBar:EnemyLifeBar;
		private function startLvl(){
			lvlTime = 0;
			//bGSound.startLoopingSoundEffect(0, 0, 0, true);
			startMonsterMaker();
			startLifeBar();
		}
		private function startLifeBar():void {
			var i:uint;
			lifeBar = new LifeBar_MC();
			addChild(lifeBar).x = stage.stageWidth / 2;
			lifeBar.y = 5;
			lifeBarNode_Array = [lifeBar.h1, lifeBar.h2, lifeBar.h3, lifeBar.h4, lifeBar.h5, lifeBar.h6, lifeBar.h7, lifeBar.h8, lifeBar.h9, lifeBar.h10, lifeBar.h11, lifeBar.h12, lifeBar.h13, lifeBar.h14, lifeBar.h15, lifeBar.h16, lifeBar.h17, lifeBar.h18, lifeBar.h19, lifeBar.h20];
			for (i = 0; i < lifeBarNode_Array.length; i++) {
				if (i + 1 > avatar.hPMax) {
					lifeBarNode_Array[i].gotoAndStop("missing");
				}
				else {
					lifeBarNode_Array[i].gotoAndStop("full");
				}
			}
			enemyLifeBar = new EnemyLifeBar();
			addChild(enemyLifeBar).x = stage.stageWidth - 10;
			enemyLifeBar.y = 5;

		}
		private function checkLifeBar():void {
			var i:uint;
			for (i = 0; i < lifeBarNode_Array.length; i++) {
				if (i + 1 > avatar.hPMax) {
					lifeBarNode_Array[i].gotoAndStop("missing");
				}
				else if (i + 1 > avatar.hPCrnt) {
					lifeBarNode_Array[i].gotoAndStop("empty");
				}
				else {
					lifeBarNode_Array[i].gotoAndStop("full");
				}
			}
			if (monsterArray[0]) {
				
			}
		}
		private function checkEnemyLifeBar():void {
			var i:uint;
			enemyLifeBar.gotoAndStop(Math.ceil((monsterArray[0].hPCrnt/monsterArray[0].hPMax)*100)+1);
		}
		private function startMonsterMaker(){
			monsterMax = lvlDefCrnt.monsterMax;
			monsterCrnt = 0;
			monsterCounterArray = new Array(0);
			var i:uint = 0;
			for(i=0;i<lvlDefCrnt.monsterArray.length;i++){
				var fMonsterHash:Object = lvlDefCrnt.monsterArray[i];
				var fCounter:Counter = new Counter(-1,-1,1,getGameTime);
				fCounter.setFreq(fMonsterHash["hFreqMin"],fMonsterHash["hFreqMax"])
				monsterCounterArray.push({hCounter:fCounter,hNum:0});
			}
		}
		private function monsterMaker(){
			var i:uint;
			var j:uint;
			if(monsterCrnt < monsterMax){
				for(i=0;i<monsterCounterArray.length;i++){
					if(lvlTime > lvlDefCrnt.monsterArray[i]["hArrive"]){//If past the arrive time of monster
						monsterCounterArray[i]["hCounter"].counterOn = true;
						monsterCounterArray[i]["hCounter"].counting();
						var fMonsterHash:Object = lvlDefCrnt.monsterArray[i];
						if(monsterCounterArray[i]["hNum"] < fMonsterHash["hNum"]){//If less than total monster count
							if(monsterCounterArray[i]["hCounter"].totalCount > 0){//If monster freq is up
								monsterCounterArray[i]["hNum"]++;
								var fYRatio:Number;
								if(fMonsterHash["hYCoordRatio"] is Function){
									fYRatio = fMonsterHash["hYCoordRatio"]();
								}
								else{
									fYRatio = fMonsterHash["hYCoordRatio"];
								}
								if(fMonsterHash["hGroup"]!=null){
									for(j=0;j<fMonsterHash["hGroup"]["hNum"];j++){
										createPhysObj(fMonsterHash["hGroup"]["hNameArray"][j%fMonsterHash["hGroup"]["hNameArray"].length], monsterOriginX+j*fMonsterHash["hGroup"]["hXInterval"],fYRatio*stage.stageHeight+j*fMonsterHash["hGroup"]["hYInterval"],"right","enemy");
										monsterCrnt++;
										if(monsterCrnt >= monsterMax){
											return;
										}
									}
								}
								else{
									monsterArray.push(createPhysObj(fMonsterHash["hName"], monsterOriginX,fYRatio*stage.stageHeight,"left","enemy"));
									monsterCrnt++;
									if(monsterCrnt >= monsterMax){
										return;
									}
								}
							}
						}
					}
				}
			}
			else{
				if(bossOn){
					if(gameTime-lastTimeBoss>=bossDelay){
						bossOn = false;
						boss = createPhysObj(lvlDefCrnt.boss["hName"], stage.stageWidth,lvlDefCrnt.boss["hYCoordRatio"]*stage.stageHeight,"left","enemy",false);
					}
				}
			}
		}
		private function lvlMv(){
			for(var i:uint; i<physObjArray.length; i++){
				if(physObjArray[i]!=avatar && physObjArray[i].physObjCreator!=avatar){
					physObjArray[i].mvSpeed.addMvSpeed({hName:"lvlMv",hVelX:lvlDefCrnt.lvlSpeed,hAccX:0,hVelY:0,hAccY:0,hTier:10},"add");
				}
			}
		}
		//GAME LOOPS+++++++++++++++++++++++++++++++++++++++++++++++++++++
		private var lastTimeGameTime:Number = 0;
		private var gameTime:Number = 0;
		private var gameRunSpeed:Number = 1;
		private var lvlTime:Number = 0;
		private function gameTimeRun() {
			var fTimePassed:uint = getTimer()-lastTimeGameTime;
			lastTimeGameTime+=fTimePassed;
			gameTime += fTimePassed*gameRunSpeed;
			lvlTime += fTimePassed * gameRunSpeed;
		}
		public function getGameTime():Number{
			return gameTime;
		}
		private function runPhysObjLoops(){
			var i:int=0;
			for(i=0;i<physObjArray.length;i++){
				if(!physObjArray[i].deathOn){
//					if(physObjArray[i] != avatar){
//						if(physObjArray[i].patternMvOn){
//							physObjArray[i].patternMv();
//						}
//					}
//					else if(physObjArray[i] == avatar){
//						physObjArray[i].runActions();
//					}
					physObjArray[i].physObjLoop();
				}
			}
		}
		private function startSkill(pSkillName:String,pPO:PhysObj,pSkillHash:Object){
			var i:int = 0;
			var fVertCond:String;
			var fPhysObjDef:PhysObjDef;
			var fCreateSucessOn:Boolean = false;
			var fCounter:Counter = pSkillHash["hCounter"];
			fPhysObjDef = new PhysObjDef();
			fPhysObjDef.setPhysObjDef(pSkillName);
			if(fCounter)fCounter.counterOn = true;
			if(fPhysObjDef.startFunc is Function)fPhysObjDef.startFunc(pPO);
			if(!avatar.weapSwitchDelayOn){
				//In order to see if there is vertCondSkill
				fVertCond = "hUpName";
				if(mouseY > avatar.y){
					fVertCond = "hDownName";
				}
			}
			for(i=0; i<fCounter.totalCount; i++){
				if(fPhysObjDef.shotsMax != -1 && !(pSkillHash["hTotalShots"] is Number && fPhysObjDef.shotsMax > pSkillHash["hTotalShots"])){
					break;
				}
				//In order to see if there is vertCondSkill
				if(pPO == avatar){
					if(fPhysObjDef.vertCondSkill!=null){
						pSkillName = fPhysObjDef.vertCondSkill[fVertCond];
					}
				}
				createAO(pSkillName, pPO, i, fCounter);
				if(pSkillHash["hTotalShots"] is Number){
					pSkillHash["hTotalShots"]++;
				}
				fCreateSucessOn = true;
			}
			if(fCreateSucessOn){
				fCounter.resetCounter();
				if(fPhysObjDef.chainSkillArray is Array && fPhysObjDef.chainSkillArray.length>0){					
					for(i=0; i<fPhysObjDef.chainSkillArray.length; i++){
						createAO(fPhysObjDef.chainSkillArray[i]["hName"],pPO,0,null);
					}
				}
				if(fPhysObjDef.castTime>0){
					var fStart:Function = function(){ControlObj(pPO).controlOffArray.push("cast");};
					var fEnd:Function = function(){ControlObj(pPO).controlOffArray.splice(ControlObj(pPO).controlOffArray.indexOf("cast"),1);};
					var fTimedEffectCast:TimedEffect = new TimedEffect(fStart,fEnd,fPhysObjDef.castTime,getGameTime,pPO.timedEffectCastArray);
					fTimedEffectCast.start();
				}
			}
		}
		private function gameLoop(e:Event){
			var i:uint = 0;
			var j:uint = 0;
			gameTimeRun();
			monsterMaker();
			runPhysObjLoops();
			if(avatar){
				for(i=0;i<avatarArray.length;i++){
					for(j=0; j<avatarArray[i].crntGraphic.numChildren; j++){
						if(getQualifiedClassName(avatarArray[i].crntGraphic.getChildAt(j)) == "DogEye"){
							avatarArray[i].startMouseAim(avatarArray[i].crntGraphic.getChildAt(j),9,-24.65);
						}
					}
				}
//				if((mouseX < avatar.x && avatar.directionFacing == "right") || (mouseX > avatar.x && avatar.directionFacing == "left")){
//					avatar.changeDirectionFacing();
//				}
			}
			if(avatar){
				if(!avatar.weapSwitchDelayOn){
					//In order to see if there is vertCondSkill
					var fVertCond:String = "hUpName";
					if(mouseY > avatar.y){
						fVertCond = "hDownName";
					}
					var fPhysObjDef:PhysObjDef;
					var fSkillName:String;
					if(avatar.specialSkill["hOn"]){
						//startSkill(avatar.specialSkill["hName"],avatar,avatar.specialSkill["hCounter"])
					}
					if(mouseDownOn){
						avatar.skillEquipArray[avatar.skillEquipCrnt]["hPhysObjDef"].startFunc(avatar);//Run physobjdef startFunc
						avatar.skillEquipArray[avatar.skillEquipCrnt]["hCounter"].counting();
						startSkill(avatar.skillEquipArray[avatar.skillEquipCrnt]["hName"],avatar,avatar.skillEquipArray[avatar.skillEquipCrnt]);
					
//						avatar.skillEquipArray[avatar.skillEquipCrnt]["hPhysObjDef"].startFunc(avatar);//Run physobjdef startFunc
//						if(avatar.skillEquipArray[avatar.skillEquipCrnt]["hCounter"]){
//							avatar.skillEquipArray[avatar.skillEquipCrnt]["hCounter"].counterOn = true;
//							avatar.skillEquipArray[avatar.skillEquipCrnt]["hCounter"].counting();
//						}
//						if(mouseFirstTimePressOn && !avatar.skillEquipArray[avatar.skillEquipCrnt]["hPhysObjDef"].autofireOn || avatar.skillEquipArray[avatar.skillEquipCrnt]["hPhysObjDef"].autofireOn){
//							startSkill(avatar.skillEquipArray[avatar.skillEquipCrnt]["hName"],avatar,avatar.skillEquipArray[avatar.skillEquipCrnt]["hCounter"]);
//							mouseFirstTimePressOn = false;
//						}
						if(avatar.selectedSkillObj!=null){
							if(avatar.selectedSkillObj["hCounter"]){
								avatar.selectedSkillObj["hCounter"].counterOn = true;
								avatar.selectedSkillObj["hCounter"].counting();
							}
							if(mouseFirstTimePressOn){ //&& !avatar.selectedSkillObj["hPhysObjDef"].autofireOn || avatar.selectedSkillObj["hPhysObjDef"].autofireOn){
								startSkill(avatar.selectedSkillObj["hName"],avatar,avatar.selectedSkillObj);
								mouseFirstTimePressOn = false;
								avatar.selectedSkillObj = null;//Reset selected skill
							}
						}
					}
					else{
						avatar.skillEquipArray[avatar.skillEquipCrnt]["hCounter"].counterOn = false;
					}
				}
				for(i=0; i<avatar.skillEquipArray.length; i++){
					if(avatar.skillEquipCrnt!=i){
						avatar.skillEquipArray[i]["hCounter"].counterOn = false;
					}
				}
			}
			for(i=0; i<playerArray.length; i++){
				if(playerArray[i] != avatar){
					if(playerArray[i].skillEquipArray.length>0){
						startSkill(playerArray[i].skillEquipArray[playerArray[i].skillEquipCrnt]["hName"],playerArray[i],playerArray[i].skillEquipArray[playerArray[i].skillEquipCrnt]);
					}
				}
			}
			Collision.testAllCollision(physObjArray,this);
			
			for(i=0;i<physObjArray.length;i++){
				physObjArray[i].damage.aFTSetDmg();
			}
			for(i=0;i<physObjArray.length;i++){
				physObjArray[i].damage.aFTHitDmg();
			}
			removeOutOfBounds();
			checkDeath(physObjArray);
			crntBG.autoInfiniteScroll(lvlDefCrnt.lvlSpeed);
			crntFG.autoInfiniteScroll(lvlDefCrnt.lvlSpeed);
			if(this.contains(crntFG)){
				setChildIndex(crntFG,this.numChildren-1);
			}
			if (avatar) {
				checkLifeBar();
			}
			if (monsterArray[0]) {
				checkEnemyLifeBar();
			}
		}
		private var boundDeathLeeway:Number = 200;
		private function removeOutOfBounds(){
			var i:uint=0;
			for(i=0;i<physObjArray.length;i++){
				switch(physObjArray[i].physObjDef.physObjType){
					case "player":
						if((physObjArray[i].physObjDef.deathBorders["hLeft"] && physObjArray[i].x<0-boundDeathLeeway) ||
							(physObjArray[i].physObjDef.deathBorders["hRight"] && physObjArray[i].x>stage.stageWidth+boundDeathLeeway) ||
							(physObjArray[i].physObjDef.deathBorders["hTop"] && physObjArray[i].y<0-boundDeathLeeway) ||
							(physObjArray[i].physObjDef.deathBorders["hBottom"] && physObjArray[i].y>stage.stageHeight+boundDeathLeeway)){
							//physObjArray[i].x = stage.stageWidth+boundDeathLeeway;
							physObjArray[i].deathOn = true;
						}
//						if(physObjArray[i].x>stage.stageWidth+boundDeathLeeway){
//							physObjArray[i].x = 0-boundDeathLeeway;
//							//physObjArray[i].deathOn = true;
//						}
						break;
					case "bullet":
						if(physObjArray[i].x+physObjArray[i].crntGraphic.width/2>stage.stageWidth+boundDeathLeeway || physObjArray[i].x-physObjArray[i].crntGraphic.width/2<0-boundDeathLeeway || physObjArray[i].y+physObjArray[i].crntGraphic.height/2<0-boundDeathLeeway-2000){
							physObjArray[i].deathOn = true;
						}
						break;
					default:
						break;
				}
			}
		}
		private var popUpBoxArray:Array = new Array(0);
		private var lvlFinishOn:Boolean = false;
		private var deathArray:Array = new Array(0);//For those who are dying
		private function checkDeath(pArray:Array){
			var i:int = 0;
			var j:int = 0;
			var fPhysObj:PhysObj;
			for(i=0; i<pArray.length; i++){
				if(pArray[i].deathOn){
					fPhysObj = pArray[i];
					for(j=0;j<fPhysObj.physObjDef.transformArray.length;j+=2){
						if (fPhysObj.physObjDef.transformArray[j + 1] == "death") {
							createAO(fPhysObj.physObjDef.transformArray[j], fPhysObj);
						}
					}
					if (monsterArray[0]) {
						if (PhysObj(monsterArray[0]).physObjDef.physObjName == "FarmerBob3") {
							if (monsterArray[0].deathOn) {
								startLevelFinish();
							}
						}
					}
					ArrayHelper.findAndRemove(physObjArray, fPhysObj, 1);
					ArrayHelper.findAndRemove(playerArray, fPhysObj, 1);
					ArrayHelper.findAndRemove(bulletArray, fPhysObj, 1);
					ArrayHelper.findAndRemove(avatarArray, fPhysObj, 1);
					ArrayHelper.findAndRemove(monsterArray, fPhysObj, 1);

					if(monsterArray.length == 0 && monsterCrnt >= monsterMax && !boss && !bossOn && !lvlFinishOn){
						if(lvlDefCrnt.boss == null){
							startLevelFinish();
						}
						else{
							bossOn = true;
							lastTimeBoss = gameTime;
						}
					}
					if (fPhysObj.crntGraphicInner != null) {
						fPhysObj.x += fPhysObj.crntGraphicInner.x;
					}
					if (fPhysObj.crntAni.changeAni(fPhysObj.crntGraphic, "startDeath", "endDeath", fPhysObj.physObjDef.aniMvHash["hDeath"]["hFreq"], getGameTime, 1, null)) {
						deathArray.push(fPhysObj);
					}
					else {
						fPhysObj.removePhysObj();
						removeChild(fPhysObj);
					}
					i--;
				}
			}
			for(i=0; i<deathArray.length; i++){
				fPhysObj = deathArray[i];
				if(fPhysObj.crntAni.getAniComplete()){
					if (this.contains(fPhysObj)) {
						fPhysObj.removePhysObj();
						removeChild(fPhysObj);
					}
					ArrayHelper.findAndRemove(deathArray, fPhysObj, 1);
					i--;
				}
			}
			if(avatar){
				if(avatar.deathOn){
					reset();
					return;
				}
			}
			/*
			if(boss){
				if(boss.deathOn && !lvlFinishOn){
					startLevelFinish();
					//reset();
				}
			}*/
		}
		private function startLevelFinish(){
			lvlFinishOn = true;
			var fLevelFinishPopUpBox:PopUpBox = new PopUpBox();
			var fLevelFinishBox:LevelFinishBox = new LevelFinishBox();
			fLevelFinishPopUpBox.x = stage.stageWidth/2;
			fLevelFinishPopUpBox.y = 0;
			addChild(fLevelFinishPopUpBox);
			fLevelFinishPopUpBox.start(fLevelFinishBox,-1,[0,0,2*fLevelFinishBox.height*(1000/500),-2*fLevelFinishBox.height*Math.pow(1000/500,2),500, 
														0,0,0,0,2000
														//0,0,-2*fLevelFinishBox.height*(1000/500),2*fLevelFinishBox.height*Math.pow(1000/500,2),500
														],getTimer);
			fLevelFinishPopUpBox.setStoreArray(popUpBoxArray);
			
			//fLevelFinishBox.txtDamage.text = "HIIII";
		}
		private function reset() {
			var i:uint;
			avatar = null;
			for (i = 0; i < physObjArray.length; i++) {
				physObjArray[i].removePhysObj();
			}
			physObjArray = new Array(0);
			playerArray = new Array(0);
			bulletArray = new Array(0);
			avatarArray = new Array(0);
			monsterArray = new Array(0);
			monsterCrnt = 0;
			monsterMax = 0;
			monsterCounterArray = new Array(0);
			boss = null;
			if (this.contains(crntBG)) {
				removeChild(crntBG);
			}
			crntBG.removeBackground();
			crntBG = new Background();
			
			if (this.contains(crntFG)) {
				removeChild(crntFG);
			}
			crntFG.removeBackground();
			crntFG = new Background();
			
			//bGSound.startFadeOutSoundEffect(2000);
			/*
			for (var i:uint=0; i < this.numChildren; i++) {
				removeChildAt(i);
				i--;
			}*/
			addChild(titleScreen);
			lvlFinishOn = false;
			
		}
		public static function getMain():Main{
			return main;
		}
		//public function get mouseX
		/*
		private function initiateGame(){
			stage.frameRate = 30;
			stage.scaleMode = StageScaleMode.NO_BORDER;
			stage.focus = stage;
			pressSpaceOST.y = 75;

			keyboardTesterInputHash = {hPlayer0:{hBlock:Z_CODE,hJump:X_CODE,hSkill:C_CODE,hNormal:V_CODE,hSpecial:B_CODE,hSelect:V_CODE,hDeselect:Z_CODE,hLeft:LEFT_ARROW_CODE,hUp:UP_ARROW_CODE,hRight:RIGHT_ARROW_CODE,hDown:DOWN_ARROW_CODE},
									   hPlayer1:{hBlock:Q_CODE,hJump:W_CODE,hSkill:E_CODE,hNormal:R_CODE,hSpecial:T_CODE,hSelect:R_CODE,hDeselect:Q_CODE,hLeft:FOUR_CODE,hUp:EIGHT_CODE,hRight:SIX_CODE,hDown:FIVE_CODE}
									  };
			loadSettings();//Replaces keyboardTesterInputHash
			difficultyMenu.gotoAndStop(difficulty);
			if(musicOn){
				soundMenu.musicSwitch.gotoAndStop("musicOn");
			}
			else{
				soundMenu.musicSwitch.gotoAndStop("musicOff");
			}
			if(soundOn){
				soundMenu.soundSwitch.gotoAndStop("soundOn");
			}
			else{
				soundMenu.soundSwitch.gotoAndStop("soundOff");
			}
			
			keyboardTesterArray.push(new KeyboardTester(keyboardTesterInputHash.hPlayer0,stage));
			keyboardTesterArray.push(new KeyboardTester(keyboardTesterInputHash.hPlayer1,stage));

			//used for GOL
			keyVarHash0 = {left:function(){return keyboardTesterArray[0].getKeyOnHash().hLeft},
							up:function(){return keyboardTesterArray[0].getKeyOnHash().hUp},
							right:function(){return keyboardTesterArray[0].getKeyOnHash().hRight},
							down:function(){return keyboardTesterArray[0].getKeyOnHash().hDown},
							choose:function(){return keyboardTesterArray[0].getKeyOnHash().hNormal}
						};
			keyVarHash1 = {left:function(){return keyboardTesterArray[1].getKeyOnHash().hLeft},
							up:function(){return keyboardTesterArray[1].getKeyOnHash().hUp},
							right:function(){return keyboardTesterArray[1].getKeyOnHash().hRight},
							down:function(){return keyboardTesterArray[1].getKeyOnHash().hDown},
							choose:function(){return keyboardTesterArray[1].getKeyOnHash().hNormal}
						};
			keyVarHash2 = {left:function(){return keyboardTesterArray[0].getKeyOnHash().hLeft},
							up:function(){return keyboardTesterArray[0].getKeyOnHash().hUp},
							right:function(){return keyboardTesterArray[0].getKeyOnHash().hRight},
							down:function(){return keyboardTesterArray[0].getKeyOnHash().hDown},
							choose:function(){return spaceKeyPressOn}
						};
			startGameMenu();
			stage.addEventListener(KeyboardEvent.KEY_DOWN,keyDownFunction);
			stage.addEventListener(KeyboardEvent.KEY_UP,keyUpFunction);
		}
		//TRANSITION++++++++++++++++++++++++++++++++++++++++++++++++++++
		public function createTransition(pTransitionMidFunc:Function,pTransitionPostGameMode:String="battleArea"){
			if(transitionOn){
				removeTransition();
			}
			if(!transitionOn){
				transitionOn = true;
				gameMode = "transition";
				transitionPostGameMode = pTransitionPostGameMode;
				transitionMidFunc=pTransitionMidFunc;
				if(!Boolean(transitionBG)){
					transitionBG = new TransitionBG();
				}
				if(transitionBG.parent==null){
					this.addChild(transitionBG);
					transitionBG.width = stage.stageWidth;
					transitionBG.height = stage.stageHeight;
					transitionBG.x=0;
					transitionBG.y=stage.stageHeight;
				}
				transitionBG.alpha = 0;
				transitionBG.visible=true;
				setChildIndex(transitionBG,numChildren-1);
				addEventListener(Event.ENTER_FRAME, transitionTime);
				if(bGSoundEffect!=null){
					bGSoundEffect.startFadeOutSoundEffect(transDuration/2);
				}
				lastTimeTrans = getTimer();
				keyDownOn = false;//Turn off keys
			}
		}
		private function transitionTime(e:Event){
			//start by turn light -> dark 
			if(getTimer()-lastTimeTrans<transDuration/2){
				transitionBG.alpha = (getTimer()-lastTimeTrans)/(transDuration/2);
			}
			//end by turn dark -> light
			else if(getTimer()-lastTimeTrans>=transDuration/2 && getTimer()-lastTimeTrans<=transDuration){
				//Call the function
				if(!transitionMidFuncOn){
					transitionMidFunc();
					transitionMidFuncOn = true;
					
					if(transitionBG.parent==null){//In case it is removed by transitionMidFunc() (e.g. unloadAll, reset, etc.)
						this.addChild(transitionBG);
						transitionBG.width = stage.stageWidth;
						transitionBG.height = stage.stageHeight;
						transitionBG.x=0;
						transitionBG.y=stage.stageHeight;
						transitionBG.visible = true;
					}
					//Make sure transitionBG is on top
					var topPosition:int = this.numChildren - 1;
					if(topPosition>=0){
						this.setChildIndex(transitionBG, topPosition);
					}
				}
				transitionBG.alpha = 1-(getTimer()-lastTimeTrans-transDuration/2)/(transDuration/2);
			}
			else if(getTimer()-lastTimeTrans>transDuration){
				removeTransition();
			}
		}
		private function removeTransition(){
			transitionOn = false;
			if(gameMode == "transition"){
				gameMode = transitionPostGameMode;
			}
			transitionMidFuncOn = false;
			transitionBG.visible=false;
			removeEventListener(Event.ENTER_FRAME, transitionTime);
			keyDownOn = true;//Turn keys back on
		}
		*/
	}
}