﻿package{
	import flash.display.MovieClip;
	public class MvSpeed extends MovieClip{
		private var _mvSpeedOn:Boolean = true;
		private var _velX:Number=0;
		private var _accX:Number=0;
		private var _velY:Number=0;
		private var _accY:Number=0;
		private var _tier:uint=0;
		private var _mvSpeedArrayA:Array = new Array(0);//Add
		private var _mvSpeedArrayR:Array = new Array(0);//Replace
		private var _mvSpeedTimerArray:Array = new Array(0);
		private var replaceMaxHash:Object = {hVelX:0,hAccX:0,hVelY:0,hAccY:0,hTier:0};
		private var replaceMaxTier:uint=0;
		public function MvSpeed(){
		}
		public function addMvSpeed(pObject:Object,pInputType:String="add"){
			var fMvSpeedArray:Array;
			var i:uint=0;
			switch(pInputType){
				case "add":
					fMvSpeedArray = _mvSpeedArrayA;
					break;
				case "replace":
					fMvSpeedArray = _mvSpeedArrayR;
					break;
			}
			removeSpeedByName(fMvSpeedArray,pObject["hName"]);
			removeSpeedByName(_mvSpeedTimerArray,pObject["hName"]);
			fMvSpeedArray.push(pObject);
			_mvSpeedTimerArray.push({hName:pObject["hName"],hElapsed:0,hDuration:pObject["hDuration"],hInputType:pInputType});
			calc(pInputType == "replace");
		}
		private function removeSpeedByName(pArray:Array,pName:String){
			var i:uint;
			for(i=0; i<pArray.length; i++){
				if(pArray[i]["hName"] == pName){
					pArray.splice(i,1);
					break;
				}
			}
		}
		public function removeSpeed(pName:String){
			removeSpeedByName(_mvSpeedArrayA,pName);
			removeSpeedByName(_mvSpeedArrayR,pName);
			removeSpeedByName(_mvSpeedTimerArray,pName);
			calc();
		}
		private function calcMaxReplace(){
			var i:uint;
			replaceMaxHash = {hVelX:0,hAccX:0,hVelY:0,hAccY:0,hTier:0};
			for(i=0; i<_mvSpeedArrayR.length; i++){
				if(_mvSpeedArrayR[i]["hTier"]>replaceMaxHash["hTier"]){
					replaceMaxHash = _mvSpeedArrayR[i];
				}
				else if(_mvSpeedArrayR[i]["hTier"]==replaceMaxHash["hTier"]){
					replaceMaxHash = _mvSpeedArrayR[i]["hTier"];
					//replaceMaxHash = {hVelX:replaceMaxHash["hVelX"]+_mvSpeedArrayR[i]["hVelX"],hAccX:replaceMaxHash["hAccX"]+_mvSpeedArrayR[i]["hAccX"],hVelY:replaceMaxHash["hVelY"]+_mvSpeedArrayR[i]["hVelY"],hAccY:replaceMaxHash["hAccY"]+_mvSpeedArrayR[i]["hAccY"],hTier:replaceMaxHash["hTier"]};
				}
			}
		}
		private function calc(pReplaceOn:Boolean=false){
			_velX=0;
			_accX=0;
			_velY=0;
			_accY=0;
			_tier=0;
			if(_mvSpeedOn){
				if(pReplaceOn){
					calcMaxReplace();
				}
				var i:uint=0;
				for(i=0;i<_mvSpeedArrayA.length;i++){
					if(_mvSpeedArrayA[i]["hTier"]>=replaceMaxHash["hTier"]){
						_tier = _mvSpeedArrayA[i]["hTier"];
						_velX += _mvSpeedArrayA[i]["hVelX"];
						_velY += _mvSpeedArrayA[i]["hVelY"];
						_accX += _mvSpeedArrayA[i]["hAccX"];
						_accY += _mvSpeedArrayA[i]["hAccY"];
					}
				}
				_tier = Math.max(_tier,replaceMaxHash["hTier"]);
				_velX += replaceMaxHash["hVelX"];
				_velY += replaceMaxHash["hVelY"];
				_accX += replaceMaxHash["hAccX"];
				_accY += replaceMaxHash["hAccY"];
			}
		}
		public function mvSpeedTimer(pTimePassed:int){//Used in PhysObj's autoMoveFunc which is looped in Main
			for(var i:uint=0;i<_mvSpeedTimerArray.length;i++){
				if(_mvSpeedTimerArray[i]["hDuration"] is Number){//If it's not null
					_mvSpeedTimerArray[i]["hElapsed"]+=pTimePassed;
					if(_mvSpeedTimerArray[i]["hElapsed"]>=_mvSpeedTimerArray[i]["hDuration"]){
						var fMvSpeedArray:Array;
						switch(_mvSpeedTimerArray[i]["hInputType"]){
							case "add":
								fMvSpeedArray = _mvSpeedArrayA;
								break;
							case "replace":
								fMvSpeedArray = _mvSpeedArrayR;
								break;
						}
						trace(_mvSpeedTimerArray[i]["hName"]);
						removeSpeedByName(fMvSpeedArray,_mvSpeedTimerArray[i]["hName"]);
						calc(_mvSpeedTimerArray[i]["hInputType"]=="replace");
						_mvSpeedTimerArray.splice(i,1);
						i--;						
					}
				}
			}
		}
		public function set mvSpeedOn(b:Boolean){
			_mvSpeedOn = b;
			if(b){
				calc(true);
			}
			else{
				_velX=0;
				_accX=0;
				_velY=0;
				_accY=0;
				_tier=0;
			}
		}
		public function get mvSpeedOn():Boolean{
			return _mvSpeedOn;
		}
		public function get velX():Number{
			return _velX;
		}
		public function get accX():Number{
			return _accX;
		}		
		public function get velY():Number{
			return _velY;
		}
		public function get accY():Number{
			return _accY;
		}
		public function set velX(n:Number){
			_velX = n;
		}
		public function set accX(n:Number){
			_accX = n;
		}		
		public function set velY(n:Number){
			_velY = n;
		}
		public function set accY(n:Number){
			_accY = n;
		}
		public function get tier():uint{
			return _tier;
		}
		public function get mvSpeedArrayA():Array{
			return _mvSpeedArrayA;
		}
		public function get mvSpeedArrayR():Array{
			return _mvSpeedArrayR;
		}
	}
}